(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.AnimationClipCreator = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.AnimationClipCreator = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var AnimationClipCreator = /*#__PURE__*/function () {
    function AnimationClipCreator() {
      _classCallCheck(this, AnimationClipCreator);
    }

    _createClass(AnimationClipCreator, null, [{
      key: "CreateRotationAnimation",
      value: function CreateRotationAnimation(period) {
        var axis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'x';
        var times = [0, period],
            values = [0, 360];
        var trackName = '.rotation[' + axis + ']';
        var track = new _three.NumberKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, period, [track]);
      }
    }, {
      key: "CreateScaleAxisAnimation",
      value: function CreateScaleAxisAnimation(period) {
        var axis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'x';
        var times = [0, period],
            values = [0, 1];
        var trackName = '.scale[' + axis + ']';
        var track = new _three.NumberKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, period, [track]);
      }
    }, {
      key: "CreateShakeAnimation",
      value: function CreateShakeAnimation(duration, shakeScale) {
        var times = [],
            values = [],
            tmp = new _three.Vector3();

        for (var i = 0; i < duration * 10; i++) {
          times.push(i / 10);
          tmp.set(Math.random() * 2.0 - 1.0, Math.random() * 2.0 - 1.0, Math.random() * 2.0 - 1.0).multiply(shakeScale).toArray(values, values.length);
        }

        var trackName = '.position';
        var track = new _three.VectorKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, duration, [track]);
      }
    }, {
      key: "CreatePulsationAnimation",
      value: function CreatePulsationAnimation(duration, pulseScale) {
        var times = [],
            values = [],
            tmp = new _three.Vector3();

        for (var i = 0; i < duration * 10; i++) {
          times.push(i / 10);
          var scaleFactor = Math.random() * pulseScale;
          tmp.set(scaleFactor, scaleFactor, scaleFactor).toArray(values, values.length);
        }

        var trackName = '.scale';
        var track = new _three.VectorKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, duration, [track]);
      }
    }, {
      key: "CreateVisibilityAnimation",
      value: function CreateVisibilityAnimation(duration) {
        var times = [0, duration / 2, duration],
            values = [true, false, true];
        var trackName = '.visible';
        var track = new _three.BooleanKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, duration, [track]);
      }
    }, {
      key: "CreateMaterialColorAnimation",
      value: function CreateMaterialColorAnimation(duration, colors) {
        var times = [],
            values = [],
            timeStep = duration / colors.length;

        for (var i = 0; i <= colors.length; i++) {
          times.push(i * timeStep);
          values.push(colors[i % colors.length]);
        }

        var trackName = '.material[0].color';
        var track = new _three.ColorKeyframeTrack(trackName, times, values);
        return new _three.AnimationClip(null, duration, [track]);
      }
    }]);

    return AnimationClipCreator;
  }();

  _exports.AnimationClipCreator = AnimationClipCreator;
});
