(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.ParallaxBarrierEffect = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ParallaxBarrierEffect = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  var ParallaxBarrierEffect = /*#__PURE__*/_createClass(function ParallaxBarrierEffect(renderer) {
    _classCallCheck(this, ParallaxBarrierEffect);

    var _camera = new _three.OrthographicCamera(-1, 1, 1, -1, 0, 1);

    var _scene = new _three.Scene();

    var _stereo = new _three.StereoCamera();

    var _params = {
      minFilter: _three.LinearFilter,
      magFilter: _three.NearestFilter,
      format: _three.RGBAFormat
    };

    var _renderTargetL = new _three.WebGLRenderTarget(512, 512, _params);

    var _renderTargetR = new _three.WebGLRenderTarget(512, 512, _params);

    var _material = new _three.ShaderMaterial({
      uniforms: {
        'mapLeft': {
          value: _renderTargetL.texture
        },
        'mapRight': {
          value: _renderTargetR.texture
        }
      },
      vertexShader: ['varying vec2 vUv;', 'void main() {', '	vUv = vec2( uv.x, uv.y );', '	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );', '}'].join('\n'),
      fragmentShader: ['uniform sampler2D mapLeft;', 'uniform sampler2D mapRight;', 'varying vec2 vUv;', 'void main() {', '	vec2 uv = vUv;', '	if ( ( mod( gl_FragCoord.y, 2.0 ) ) > 1.00 ) {', '		gl_FragColor = texture2D( mapLeft, uv );', '	} else {', '		gl_FragColor = texture2D( mapRight, uv );', '	}', '}'].join('\n')
    });

    var mesh = new _three.Mesh(new _three.PlaneGeometry(2, 2), _material);

    _scene.add(mesh);

    this.setSize = function (width, height) {
      renderer.setSize(width, height);
      var pixelRatio = renderer.getPixelRatio();

      _renderTargetL.setSize(width * pixelRatio, height * pixelRatio);

      _renderTargetR.setSize(width * pixelRatio, height * pixelRatio);
    };

    this.render = function (scene, camera) {
      scene.updateMatrixWorld();
      if (camera.parent === null) camera.updateMatrixWorld();

      _stereo.update(camera);

      renderer.setRenderTarget(_renderTargetL);
      renderer.clear();
      renderer.render(scene, _stereo.cameraL);
      renderer.setRenderTarget(_renderTargetR);
      renderer.clear();
      renderer.render(scene, _stereo.cameraR);
      renderer.setRenderTarget(null);
      renderer.render(_scene, _camera);
    };
  });

  _exports.ParallaxBarrierEffect = ParallaxBarrierEffect;
});
