(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../math/ConvexHull.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../math/ConvexHull.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.ConvexHull);
    global.ConvexGeometry = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _ConvexHull) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ConvexGeometry = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var ConvexGeometry = /*#__PURE__*/function (_BufferGeometry) {
    _inherits(ConvexGeometry, _BufferGeometry);

    var _super = _createSuper(ConvexGeometry);

    function ConvexGeometry(points) {
      var _this;

      _classCallCheck(this, ConvexGeometry);

      _this = _super.call(this); // buffers

      var vertices = [];
      var normals = [];

      if (_ConvexHull.ConvexHull === undefined) {
        console.error('THREE.ConvexBufferGeometry: ConvexBufferGeometry relies on ConvexHull');
      }

      var convexHull = new _ConvexHull.ConvexHull().setFromPoints(points); // generate vertices and normals

      var faces = convexHull.faces;

      for (var i = 0; i < faces.length; i++) {
        var face = faces[i];
        var edge = face.edge; // we move along a doubly-connected edge list to access all face points (see HalfEdge docs)

        do {
          var point = edge.head().point;
          vertices.push(point.x, point.y, point.z);
          normals.push(face.normal.x, face.normal.y, face.normal.z);
          edge = edge.next;
        } while (edge !== face.edge);
      } // build geometry


      _this.setAttribute('position', new _three.Float32BufferAttribute(vertices, 3));

      _this.setAttribute('normal', new _three.Float32BufferAttribute(normals, 3));

      return _this;
    }

    return _createClass(ConvexGeometry);
  }(_three.BufferGeometry);

  _exports.ConvexGeometry = ConvexGeometry;
});
