(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.PositionalAudioHelper = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.PositionalAudioHelper = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var PositionalAudioHelper = /*#__PURE__*/function (_Line) {
    _inherits(PositionalAudioHelper, _Line);

    var _super = _createSuper(PositionalAudioHelper);

    function PositionalAudioHelper(audio) {
      var _this;

      var range = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var divisionsInnerAngle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 16;
      var divisionsOuterAngle = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 2;

      _classCallCheck(this, PositionalAudioHelper);

      var geometry = new _three.BufferGeometry();
      var divisions = divisionsInnerAngle + divisionsOuterAngle * 2;
      var positions = new Float32Array((divisions * 3 + 3) * 3);
      geometry.setAttribute('position', new _three.BufferAttribute(positions, 3));
      var materialInnerAngle = new _three.LineBasicMaterial({
        color: 0x00ff00
      });
      var materialOuterAngle = new _three.LineBasicMaterial({
        color: 0xffff00
      });
      _this = _super.call(this, geometry, [materialOuterAngle, materialInnerAngle]);
      _this.audio = audio;
      _this.range = range;
      _this.divisionsInnerAngle = divisionsInnerAngle;
      _this.divisionsOuterAngle = divisionsOuterAngle;
      _this.type = 'PositionalAudioHelper';

      _this.update();

      return _this;
    }

    _createClass(PositionalAudioHelper, [{
      key: "update",
      value: function update() {
        var audio = this.audio;
        var range = this.range;
        var divisionsInnerAngle = this.divisionsInnerAngle;
        var divisionsOuterAngle = this.divisionsOuterAngle;

        var coneInnerAngle = _three.MathUtils.degToRad(audio.panner.coneInnerAngle);

        var coneOuterAngle = _three.MathUtils.degToRad(audio.panner.coneOuterAngle);

        var halfConeInnerAngle = coneInnerAngle / 2;
        var halfConeOuterAngle = coneOuterAngle / 2;
        var start = 0;
        var count = 0;
        var i;
        var stride;
        var geometry = this.geometry;
        var positionAttribute = geometry.attributes.position;
        geometry.clearGroups(); //

        function generateSegment(from, to, divisions, materialIndex) {
          var step = (to - from) / divisions;
          positionAttribute.setXYZ(start, 0, 0, 0);
          count++;

          for (i = from; i < to; i += step) {
            stride = start + count;
            positionAttribute.setXYZ(stride, Math.sin(i) * range, 0, Math.cos(i) * range);
            positionAttribute.setXYZ(stride + 1, Math.sin(Math.min(i + step, to)) * range, 0, Math.cos(Math.min(i + step, to)) * range);
            positionAttribute.setXYZ(stride + 2, 0, 0, 0);
            count += 3;
          }

          geometry.addGroup(start, count, materialIndex);
          start += count;
          count = 0;
        } //


        generateSegment(-halfConeOuterAngle, -halfConeInnerAngle, divisionsOuterAngle, 0);
        generateSegment(-halfConeInnerAngle, halfConeInnerAngle, divisionsInnerAngle, 1);
        generateSegment(halfConeInnerAngle, halfConeOuterAngle, divisionsOuterAngle, 0); //

        positionAttribute.needsUpdate = true;
        if (coneInnerAngle === coneOuterAngle) this.material[0].visible = false;
      }
    }, {
      key: "dispose",
      value: function dispose() {
        this.geometry.dispose();
        this.material[0].dispose();
        this.material[1].dispose();
      }
    }]);

    return PositionalAudioHelper;
  }(_three.Line);

  _exports.PositionalAudioHelper = PositionalAudioHelper;
});
