(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.RectAreaLightHelper = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RectAreaLightHelper = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  /**
   *  This helper must be added as a child of the light
   */
  var RectAreaLightHelper = /*#__PURE__*/function (_Line) {
    _inherits(RectAreaLightHelper, _Line);

    var _super = _createSuper(RectAreaLightHelper);

    function RectAreaLightHelper(light, color) {
      var _this;

      _classCallCheck(this, RectAreaLightHelper);

      var positions = [1, 1, 0, -1, 1, 0, -1, -1, 0, 1, -1, 0, 1, 1, 0];
      var geometry = new _three.BufferGeometry();
      geometry.setAttribute('position', new _three.Float32BufferAttribute(positions, 3));
      geometry.computeBoundingSphere();
      var material = new _three.LineBasicMaterial({
        fog: false
      });
      _this = _super.call(this, geometry, material);
      _this.light = light;
      _this.color = color; // optional hardwired color for the helper

      _this.type = 'RectAreaLightHelper'; //

      var positions2 = [1, 1, 0, -1, 1, 0, -1, -1, 0, 1, 1, 0, -1, -1, 0, 1, -1, 0];
      var geometry2 = new _three.BufferGeometry();
      geometry2.setAttribute('position', new _three.Float32BufferAttribute(positions2, 3));
      geometry2.computeBoundingSphere();

      _this.add(new _three.Mesh(geometry2, new _three.MeshBasicMaterial({
        side: _three.BackSide,
        fog: false
      })));

      return _this;
    }

    _createClass(RectAreaLightHelper, [{
      key: "updateMatrixWorld",
      value: function updateMatrixWorld() {
        this.scale.set(0.5 * this.light.width, 0.5 * this.light.height, 1);

        if (this.color !== undefined) {
          this.material.color.set(this.color);
          this.children[0].material.color.set(this.color);
        } else {
          this.material.color.copy(this.light.color).multiplyScalar(this.light.intensity); // prevent hue shift

          var c = this.material.color;
          var max = Math.max(c.r, c.g, c.b);
          if (max > 1) c.multiplyScalar(1 / max);
          this.children[0].material.color.copy(this.material.color);
        } // ignore world scale on light


        this.matrixWorld.extractRotation(this.light.matrixWorld).scale(this.scale).copyPosition(this.light.matrixWorld);
        this.children[0].matrixWorld.copy(this.matrixWorld);
      }
    }, {
      key: "dispose",
      value: function dispose() {
        this.geometry.dispose();
        this.material.dispose();
        this.children[0].geometry.dispose();
        this.children[0].material.dispose();
      }
    }]);

    return RectAreaLightHelper;
  }(_three.Line);

  _exports.RectAreaLightHelper = RectAreaLightHelper;
});
