(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.VertexNormalsHelper = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.VertexNormalsHelper = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var _v1 = new _three.Vector3();

  var _v2 = new _three.Vector3();

  var _normalMatrix = new _three.Matrix3();

  var VertexNormalsHelper = /*#__PURE__*/function (_LineSegments) {
    _inherits(VertexNormalsHelper, _LineSegments);

    var _super = _createSuper(VertexNormalsHelper);

    function VertexNormalsHelper(object) {
      var _this;

      var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var color = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0xff0000;

      _classCallCheck(this, VertexNormalsHelper);

      var nNormals = 0;
      var objGeometry = object.geometry;

      if (objGeometry && objGeometry.isGeometry) {
        console.error('THREE.VertexNormalsHelper no longer supports Geometry. Use BufferGeometry instead.');
        return _possibleConstructorReturn(_this);
      } else if (objGeometry && objGeometry.isBufferGeometry) {
        nNormals = objGeometry.attributes.normal.count;
      } //


      var geometry = new _three.BufferGeometry();
      var positions = new _three.Float32BufferAttribute(nNormals * 2 * 3, 3);
      geometry.setAttribute('position', positions);
      _this = _super.call(this, geometry, new _three.LineBasicMaterial({
        color: color,
        toneMapped: false
      }));
      _this.object = object;
      _this.size = size;
      _this.type = 'VertexNormalsHelper'; //

      _this.matrixAutoUpdate = false;

      _this.update();

      return _this;
    }

    _createClass(VertexNormalsHelper, [{
      key: "update",
      value: function update() {
        this.object.updateMatrixWorld(true);

        _normalMatrix.getNormalMatrix(this.object.matrixWorld);

        var matrixWorld = this.object.matrixWorld;
        var position = this.geometry.attributes.position; //

        var objGeometry = this.object.geometry;

        if (objGeometry && objGeometry.isGeometry) {
          console.error('THREE.VertexNormalsHelper no longer supports Geometry. Use BufferGeometry instead.');
          return;
        } else if (objGeometry && objGeometry.isBufferGeometry) {
          var objPos = objGeometry.attributes.position;
          var objNorm = objGeometry.attributes.normal;
          var idx = 0; // for simplicity, ignore index and drawcalls, and render every normal

          for (var j = 0, jl = objPos.count; j < jl; j++) {
            _v1.set(objPos.getX(j), objPos.getY(j), objPos.getZ(j)).applyMatrix4(matrixWorld);

            _v2.set(objNorm.getX(j), objNorm.getY(j), objNorm.getZ(j));

            _v2.applyMatrix3(_normalMatrix).normalize().multiplyScalar(this.size).add(_v1);

            position.setXYZ(idx, _v1.x, _v1.y, _v1.z);
            idx = idx + 1;
            position.setXYZ(idx, _v2.x, _v2.y, _v2.z);
            idx = idx + 1;
          }
        }

        position.needsUpdate = true;
      }
    }]);

    return VertexNormalsHelper;
  }(_three.LineSegments);

  _exports.VertexNormalsHelper = VertexNormalsHelper;
});
