(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.SelectionHelper = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SelectionHelper = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var SelectionHelper = /*#__PURE__*/function () {
    function SelectionHelper(selectionBox, renderer, cssClassName) {
      _classCallCheck(this, SelectionHelper);

      this.element = document.createElement('div');
      this.element.classList.add(cssClassName);
      this.element.style.pointerEvents = 'none';
      this.renderer = renderer;
      this.startPoint = new _three.Vector2();
      this.pointTopLeft = new _three.Vector2();
      this.pointBottomRight = new _three.Vector2();
      this.isDown = false;
      this.renderer.domElement.addEventListener('pointerdown', function (event) {
        this.isDown = true;
        this.onSelectStart(event);
      }.bind(this));
      this.renderer.domElement.addEventListener('pointermove', function (event) {
        if (this.isDown) {
          this.onSelectMove(event);
        }
      }.bind(this));
      this.renderer.domElement.addEventListener('pointerup', function (event) {
        this.isDown = false;
        this.onSelectOver(event);
      }.bind(this));
    }

    _createClass(SelectionHelper, [{
      key: "onSelectStart",
      value: function onSelectStart(event) {
        this.renderer.domElement.parentElement.appendChild(this.element);
        this.element.style.left = event.clientX + 'px';
        this.element.style.top = event.clientY + 'px';
        this.element.style.width = '0px';
        this.element.style.height = '0px';
        this.startPoint.x = event.clientX;
        this.startPoint.y = event.clientY;
      }
    }, {
      key: "onSelectMove",
      value: function onSelectMove(event) {
        this.pointBottomRight.x = Math.max(this.startPoint.x, event.clientX);
        this.pointBottomRight.y = Math.max(this.startPoint.y, event.clientY);
        this.pointTopLeft.x = Math.min(this.startPoint.x, event.clientX);
        this.pointTopLeft.y = Math.min(this.startPoint.y, event.clientY);
        this.element.style.left = this.pointTopLeft.x + 'px';
        this.element.style.top = this.pointTopLeft.y + 'px';
        this.element.style.width = this.pointBottomRight.x - this.pointTopLeft.x + 'px';
        this.element.style.height = this.pointBottomRight.y - this.pointTopLeft.y + 'px';
      }
    }, {
      key: "onSelectOver",
      value: function onSelectOver() {
        this.element.parentElement.removeChild(this.element);
      }
    }]);

    return SelectionHelper;
  }();

  _exports.SelectionHelper = SelectionHelper;
});
