(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./OimoPhysics.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./OimoPhysics.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.OimoPhysics);
    global.index = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _OimoPhysics) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.World = _exports.Vec3 = _exports.UniversalJointConfig = _exports.UniversalJoint = _exports.TranslationalLimitMotor = _exports.Transform = _exports.SpringDamper = _exports.SphericalJointConfig = _exports.SphericalJoint = _exports.ShapeConfig = _exports.Shape = _exports.RotationalLimitMotor = _exports.RigidBodyType = _exports.RigidBodyConfig = _exports.RigidBody = _exports.RevoluteJointConfig = _exports.RevoluteJoint = _exports.RayCastClosest = _exports.RagdollJointConfig = _exports.RagdollJoint = _exports.Quat = _exports.PrismaticJointConfig = _exports.PrismaticJoint = _exports.OSphereGeometry = _exports.OGeometry = _exports.OCylinderGeometry = _exports.OConvexHullGeometry = _exports.OConeGeometry = _exports.OCapsuleGeometry = _exports.OBoxGeometry = _exports.MathUtil = _exports.Mat3 = _exports.CylindricalJointConfig = _exports.CylindricalJoint = void 0;
  // dynamics
  var World = _OimoPhysics.oimo.dynamics.World;
  _exports.World = World;
  var RigidBodyType = _OimoPhysics.oimo.dynamics.rigidbody.RigidBodyType;
  _exports.RigidBodyType = RigidBodyType;
  var RigidBodyConfig = _OimoPhysics.oimo.dynamics.rigidbody.RigidBodyConfig;
  _exports.RigidBodyConfig = RigidBodyConfig;
  var ShapeConfig = _OimoPhysics.oimo.dynamics.rigidbody.ShapeConfig;
  _exports.ShapeConfig = ShapeConfig;
  var RigidBody = _OimoPhysics.oimo.dynamics.rigidbody.RigidBody;
  _exports.RigidBody = RigidBody;
  var Shape = _OimoPhysics.oimo.dynamics.rigidbody.Shape;
  _exports.Shape = Shape;
  var SphericalJoint = _OimoPhysics.oimo.dynamics.constraint.joint.SphericalJoint;
  _exports.SphericalJoint = SphericalJoint;
  var RevoluteJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.RevoluteJointConfig;
  _exports.RevoluteJointConfig = RevoluteJointConfig;
  var UniversalJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.UniversalJointConfig;
  _exports.UniversalJointConfig = UniversalJointConfig;
  var CylindricalJoint = _OimoPhysics.oimo.dynamics.constraint.joint.CylindricalJoint;
  _exports.CylindricalJoint = CylindricalJoint;
  var PrismaticJoint = _OimoPhysics.oimo.dynamics.constraint.joint.PrismaticJoint;
  _exports.PrismaticJoint = PrismaticJoint;
  var PrismaticJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.PrismaticJointConfig;
  _exports.PrismaticJointConfig = PrismaticJointConfig;
  var RevoluteJoint = _OimoPhysics.oimo.dynamics.constraint.joint.RevoluteJoint;
  _exports.RevoluteJoint = RevoluteJoint;
  var RagdollJoint = _OimoPhysics.oimo.dynamics.constraint.joint.RagdollJoint;
  _exports.RagdollJoint = RagdollJoint;
  var CylindricalJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.CylindricalJointConfig;
  _exports.CylindricalJointConfig = CylindricalJointConfig;
  var SphericalJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.SphericalJointConfig;
  _exports.SphericalJointConfig = SphericalJointConfig;
  var RagdollJointConfig = _OimoPhysics.oimo.dynamics.constraint.joint.RagdollJointConfig;
  _exports.RagdollJointConfig = RagdollJointConfig;
  var SpringDamper = _OimoPhysics.oimo.dynamics.constraint.joint.SpringDamper;
  _exports.SpringDamper = SpringDamper;
  var TranslationalLimitMotor = _OimoPhysics.oimo.dynamics.constraint.joint.TranslationalLimitMotor;
  _exports.TranslationalLimitMotor = TranslationalLimitMotor;
  var RotationalLimitMotor = _OimoPhysics.oimo.dynamics.constraint.joint.RotationalLimitMotor;
  _exports.RotationalLimitMotor = RotationalLimitMotor;
  var UniversalJoint = _OimoPhysics.oimo.dynamics.constraint.joint.UniversalJoint; // common

  _exports.UniversalJoint = UniversalJoint;
  var Vec3 = _OimoPhysics.oimo.common.Vec3;
  _exports.Vec3 = Vec3;
  var Quat = _OimoPhysics.oimo.common.Quat;
  _exports.Quat = Quat;
  var Mat3 = _OimoPhysics.oimo.common.Mat3;
  _exports.Mat3 = Mat3;
  var MathUtil = _OimoPhysics.oimo.common.MathUtil;
  _exports.MathUtil = MathUtil;
  var Transform = _OimoPhysics.oimo.common.Transform; // collision

  _exports.Transform = Transform;
  var OCapsuleGeometry = _OimoPhysics.oimo.collision.geometry.CapsuleGeometry;
  _exports.OCapsuleGeometry = OCapsuleGeometry;
  var OConvexHullGeometry = _OimoPhysics.oimo.collision.geometry.ConvexHullGeometry;
  _exports.OConvexHullGeometry = OConvexHullGeometry;
  var OBoxGeometry = _OimoPhysics.oimo.collision.geometry.BoxGeometry;
  _exports.OBoxGeometry = OBoxGeometry;
  var OSphereGeometry = _OimoPhysics.oimo.collision.geometry.SphereGeometry;
  _exports.OSphereGeometry = OSphereGeometry;
  var OCylinderGeometry = _OimoPhysics.oimo.collision.geometry.CylinderGeometry;
  _exports.OCylinderGeometry = OCylinderGeometry;
  var OConeGeometry = _OimoPhysics.oimo.collision.geometry.ConeGeometry;
  _exports.OConeGeometry = OConeGeometry;
  var OGeometry = _OimoPhysics.oimo.collision.geometry.Geometry; // callback

  _exports.OGeometry = OGeometry;
  var RayCastClosest = _OimoPhysics.oimo.dynamics.callback.RayCastClosest;
  _exports.RayCastClosest = RayCastClosest;
});
