(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../lines/LineSegmentsGeometry.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../lines/LineSegmentsGeometry.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.LineSegmentsGeometry);
    global.LineGeometry = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _LineSegmentsGeometry2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LineGeometry = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var LineGeometry = /*#__PURE__*/function (_LineSegmentsGeometry) {
    _inherits(LineGeometry, _LineSegmentsGeometry);

    var _super = _createSuper(LineGeometry);

    function LineGeometry() {
      var _this;

      _classCallCheck(this, LineGeometry);

      _this = _super.call(this);
      _this.type = 'LineGeometry';
      return _this;
    }

    _createClass(LineGeometry, [{
      key: "setPositions",
      value: function setPositions(array) {
        // converts [ x1, y1, z1,  x2, y2, z2, ... ] to pairs format
        var length = array.length - 3;
        var points = new Float32Array(2 * length);

        for (var i = 0; i < length; i += 3) {
          points[2 * i] = array[i];
          points[2 * i + 1] = array[i + 1];
          points[2 * i + 2] = array[i + 2];
          points[2 * i + 3] = array[i + 3];
          points[2 * i + 4] = array[i + 4];
          points[2 * i + 5] = array[i + 5];
        }

        _get(_getPrototypeOf(LineGeometry.prototype), "setPositions", this).call(this, points);

        return this;
      }
    }, {
      key: "setColors",
      value: function setColors(array) {
        // converts [ r1, g1, b1,  r2, g2, b2, ... ] to pairs format
        var length = array.length - 3;
        var colors = new Float32Array(2 * length);

        for (var i = 0; i < length; i += 3) {
          colors[2 * i] = array[i];
          colors[2 * i + 1] = array[i + 1];
          colors[2 * i + 2] = array[i + 2];
          colors[2 * i + 3] = array[i + 3];
          colors[2 * i + 4] = array[i + 4];
          colors[2 * i + 5] = array[i + 5];
        }

        _get(_getPrototypeOf(LineGeometry.prototype), "setColors", this).call(this, colors);

        return this;
      }
    }, {
      key: "fromLine",
      value: function fromLine(line) {
        var geometry = line.geometry;

        if (geometry.isGeometry) {
          console.error('THREE.LineGeometry no longer supports Geometry. Use THREE.BufferGeometry instead.');
          return;
        } else if (geometry.isBufferGeometry) {
          this.setPositions(geometry.attributes.position.array); // assumes non-indexed
        } // set colors, maybe


        return this;
      }
    }]);

    return LineGeometry;
  }(_LineSegmentsGeometry2.LineSegmentsGeometry);

  _exports.LineGeometry = LineGeometry;
  LineGeometry.prototype.isLineGeometry = true;
});
