(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.LineSegmentsGeometry = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LineSegmentsGeometry = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var _box = new _three.Box3();

  var _vector = new _three.Vector3();

  var LineSegmentsGeometry = /*#__PURE__*/function (_InstancedBufferGeome) {
    _inherits(LineSegmentsGeometry, _InstancedBufferGeome);

    var _super = _createSuper(LineSegmentsGeometry);

    function LineSegmentsGeometry() {
      var _this;

      _classCallCheck(this, LineSegmentsGeometry);

      _this = _super.call(this);
      _this.type = 'LineSegmentsGeometry';
      var positions = [-1, 2, 0, 1, 2, 0, -1, 1, 0, 1, 1, 0, -1, 0, 0, 1, 0, 0, -1, -1, 0, 1, -1, 0];
      var uvs = [-1, 2, 1, 2, -1, 1, 1, 1, -1, -1, 1, -1, -1, -2, 1, -2];
      var index = [0, 2, 1, 2, 3, 1, 2, 4, 3, 4, 5, 3, 4, 6, 5, 6, 7, 5];

      _this.setIndex(index);

      _this.setAttribute('position', new _three.Float32BufferAttribute(positions, 3));

      _this.setAttribute('uv', new _three.Float32BufferAttribute(uvs, 2));

      return _this;
    }

    _createClass(LineSegmentsGeometry, [{
      key: "applyMatrix4",
      value: function applyMatrix4(matrix) {
        var start = this.attributes.instanceStart;
        var end = this.attributes.instanceEnd;

        if (start !== undefined) {
          start.applyMatrix4(matrix);
          end.applyMatrix4(matrix);
          start.needsUpdate = true;
        }

        if (this.boundingBox !== null) {
          this.computeBoundingBox();
        }

        if (this.boundingSphere !== null) {
          this.computeBoundingSphere();
        }

        return this;
      }
    }, {
      key: "setPositions",
      value: function setPositions(array) {
        var lineSegments;

        if (array instanceof Float32Array) {
          lineSegments = array;
        } else if (Array.isArray(array)) {
          lineSegments = new Float32Array(array);
        }

        var instanceBuffer = new _three.InstancedInterleavedBuffer(lineSegments, 6, 1); // xyz, xyz

        this.setAttribute('instanceStart', new _three.InterleavedBufferAttribute(instanceBuffer, 3, 0)); // xyz

        this.setAttribute('instanceEnd', new _three.InterleavedBufferAttribute(instanceBuffer, 3, 3)); // xyz
        //

        this.computeBoundingBox();
        this.computeBoundingSphere();
        return this;
      }
    }, {
      key: "setColors",
      value: function setColors(array) {
        var colors;

        if (array instanceof Float32Array) {
          colors = array;
        } else if (Array.isArray(array)) {
          colors = new Float32Array(array);
        }

        var instanceColorBuffer = new _three.InstancedInterleavedBuffer(colors, 6, 1); // rgb, rgb

        this.setAttribute('instanceColorStart', new _three.InterleavedBufferAttribute(instanceColorBuffer, 3, 0)); // rgb

        this.setAttribute('instanceColorEnd', new _three.InterleavedBufferAttribute(instanceColorBuffer, 3, 3)); // rgb

        return this;
      }
    }, {
      key: "fromWireframeGeometry",
      value: function fromWireframeGeometry(geometry) {
        this.setPositions(geometry.attributes.position.array);
        return this;
      }
    }, {
      key: "fromEdgesGeometry",
      value: function fromEdgesGeometry(geometry) {
        this.setPositions(geometry.attributes.position.array);
        return this;
      }
    }, {
      key: "fromMesh",
      value: function fromMesh(mesh) {
        this.fromWireframeGeometry(new _three.WireframeGeometry(mesh.geometry)); // set colors, maybe

        return this;
      }
    }, {
      key: "fromLineSegments",
      value: function fromLineSegments(lineSegments) {
        var geometry = lineSegments.geometry;

        if (geometry.isGeometry) {
          console.error('THREE.LineSegmentsGeometry no longer supports Geometry. Use THREE.BufferGeometry instead.');
          return;
        } else if (geometry.isBufferGeometry) {
          this.setPositions(geometry.attributes.position.array); // assumes non-indexed
        } // set colors, maybe


        return this;
      }
    }, {
      key: "computeBoundingBox",
      value: function computeBoundingBox() {
        if (this.boundingBox === null) {
          this.boundingBox = new _three.Box3();
        }

        var start = this.attributes.instanceStart;
        var end = this.attributes.instanceEnd;

        if (start !== undefined && end !== undefined) {
          this.boundingBox.setFromBufferAttribute(start);

          _box.setFromBufferAttribute(end);

          this.boundingBox.union(_box);
        }
      }
    }, {
      key: "computeBoundingSphere",
      value: function computeBoundingSphere() {
        if (this.boundingSphere === null) {
          this.boundingSphere = new _three.Sphere();
        }

        if (this.boundingBox === null) {
          this.computeBoundingBox();
        }

        var start = this.attributes.instanceStart;
        var end = this.attributes.instanceEnd;

        if (start !== undefined && end !== undefined) {
          var center = this.boundingSphere.center;
          this.boundingBox.getCenter(center);
          var maxRadiusSq = 0;

          for (var i = 0, il = start.count; i < il; i++) {
            _vector.fromBufferAttribute(start, i);

            maxRadiusSq = Math.max(maxRadiusSq, center.distanceToSquared(_vector));

            _vector.fromBufferAttribute(end, i);

            maxRadiusSq = Math.max(maxRadiusSq, center.distanceToSquared(_vector));
          }

          this.boundingSphere.radius = Math.sqrt(maxRadiusSq);

          if (isNaN(this.boundingSphere.radius)) {
            console.error('THREE.LineSegmentsGeometry.computeBoundingSphere(): Computed radius is NaN. The instanced position data is likely to have NaN values.', this);
          }
        }
      }
    }, {
      key: "toJSON",
      value: function toJSON() {// todo
      }
    }, {
      key: "applyMatrix",
      value: function applyMatrix(matrix) {
        console.warn('THREE.LineSegmentsGeometry: applyMatrix() has been renamed to applyMatrix4().');
        return this.applyMatrix4(matrix);
      }
    }]);

    return LineSegmentsGeometry;
  }(_three.InstancedBufferGeometry);

  _exports.LineSegmentsGeometry = LineSegmentsGeometry;
  LineSegmentsGeometry.prototype.isLineSegmentsGeometry = true;
});
