(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../lines/LineSegmentsGeometry.js", "../lines/LineMaterial.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../lines/LineSegmentsGeometry.js"), require("../lines/LineMaterial.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.LineSegmentsGeometry, global.LineMaterial);
    global.Wireframe = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _LineSegmentsGeometry, _LineMaterial) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Wireframe = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var _start = new _three.Vector3();

  var _end = new _three.Vector3();

  var Wireframe = /*#__PURE__*/function (_Mesh) {
    _inherits(Wireframe, _Mesh);

    var _super = _createSuper(Wireframe);

    function Wireframe() {
      var _this;

      var geometry = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new _LineSegmentsGeometry.LineSegmentsGeometry();
      var material = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _LineMaterial.LineMaterial({
        color: Math.random() * 0xffffff
      });

      _classCallCheck(this, Wireframe);

      _this = _super.call(this, geometry, material);
      _this.type = 'Wireframe';
      return _this;
    } // for backwards-compatability, but could be a method of LineSegmentsGeometry...


    _createClass(Wireframe, [{
      key: "computeLineDistances",
      value: function computeLineDistances() {
        var geometry = this.geometry;
        var instanceStart = geometry.attributes.instanceStart;
        var instanceEnd = geometry.attributes.instanceEnd;
        var lineDistances = new Float32Array(2 * instanceStart.count);

        for (var i = 0, j = 0, l = instanceStart.count; i < l; i++, j += 2) {
          _start.fromBufferAttribute(instanceStart, i);

          _end.fromBufferAttribute(instanceEnd, i);

          lineDistances[j] = j === 0 ? 0 : lineDistances[j - 1];
          lineDistances[j + 1] = lineDistances[j] + _start.distanceTo(_end);
        }

        var instanceDistanceBuffer = new _three.InstancedInterleavedBuffer(lineDistances, 2, 1); // d0, d1

        geometry.setAttribute('instanceDistanceStart', new _three.InterleavedBufferAttribute(instanceDistanceBuffer, 1, 0)); // d0

        geometry.setAttribute('instanceDistanceEnd', new _three.InterleavedBufferAttribute(instanceDistanceBuffer, 1, 1)); // d1

        return this;
      }
    }]);

    return Wireframe;
  }(_three.Mesh);

  _exports.Wireframe = Wireframe;
  Wireframe.prototype.isWireframe = true;
});
