(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../loaders/RGBELoader.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../loaders/RGBELoader.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.RGBELoader);
    global.HDRCubeTextureLoader = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _RGBELoader) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HDRCubeTextureLoader = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var HDRCubeTextureLoader = /*#__PURE__*/function (_Loader) {
    _inherits(HDRCubeTextureLoader, _Loader);

    var _super = _createSuper(HDRCubeTextureLoader);

    function HDRCubeTextureLoader(manager) {
      var _this;

      _classCallCheck(this, HDRCubeTextureLoader);

      _this = _super.call(this, manager);
      _this.hdrLoader = new _RGBELoader.RGBELoader();
      _this.type = _three.HalfFloatType;
      return _this;
    }

    _createClass(HDRCubeTextureLoader, [{
      key: "load",
      value: function load(urls, onLoad, onProgress, onError) {
        if (!Array.isArray(urls)) {
          console.warn('THREE.HDRCubeTextureLoader signature has changed. Use .setDataType() instead.');
          this.setDataType(urls);
          urls = onLoad;
          onLoad = onProgress;
          onProgress = onError;
          onError = arguments[4];
        }

        var texture = new _three.CubeTexture();
        texture.type = this.type;

        switch (texture.type) {
          case _three.UnsignedByteType:
            texture.encoding = _three.RGBEEncoding;
            texture.format = _three.RGBAFormat;
            texture.minFilter = _three.NearestFilter;
            texture.magFilter = _three.NearestFilter;
            texture.generateMipmaps = false;
            break;

          case _three.FloatType:
            texture.encoding = _three.LinearEncoding;
            texture.format = _three.RGBFormat;
            texture.minFilter = _three.LinearFilter;
            texture.magFilter = _three.LinearFilter;
            texture.generateMipmaps = false;
            break;

          case _three.HalfFloatType:
            texture.encoding = _three.LinearEncoding;
            texture.format = _three.RGBFormat;
            texture.minFilter = _three.LinearFilter;
            texture.magFilter = _three.LinearFilter;
            texture.generateMipmaps = false;
            break;
        }

        var scope = this;
        var loaded = 0;

        function loadHDRData(i, onLoad, onProgress, onError) {
          new _three.FileLoader(scope.manager).setPath(scope.path).setResponseType('arraybuffer').setWithCredentials(scope.withCredentials).load(urls[i], function (buffer) {
            loaded++;
            var texData = scope.hdrLoader.parse(buffer);
            if (!texData) return;

            if (texData.data !== undefined) {
              var dataTexture = new _three.DataTexture(texData.data, texData.width, texData.height);
              dataTexture.type = texture.type;
              dataTexture.encoding = texture.encoding;
              dataTexture.format = texture.format;
              dataTexture.minFilter = texture.minFilter;
              dataTexture.magFilter = texture.magFilter;
              dataTexture.generateMipmaps = texture.generateMipmaps;
              texture.images[i] = dataTexture;
            }

            if (loaded === 6) {
              texture.needsUpdate = true;
              if (onLoad) onLoad(texture);
            }
          }, onProgress, onError);
        }

        for (var i = 0; i < urls.length; i++) {
          loadHDRData(i, onLoad, onProgress, onError);
        }

        return texture;
      }
    }, {
      key: "setDataType",
      value: function setDataType(value) {
        this.type = value;
        this.hdrLoader.setDataType(value);
        return this;
      }
    }]);

    return HDRCubeTextureLoader;
  }(_three.Loader);

  _exports.HDRCubeTextureLoader = HDRCubeTextureLoader;
});
