(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.MDDLoader = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MDDLoader = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var MDDLoader = /*#__PURE__*/function (_Loader) {
    _inherits(MDDLoader, _Loader);

    var _super = _createSuper(MDDLoader);

    function MDDLoader(manager) {
      _classCallCheck(this, MDDLoader);

      return _super.call(this, manager);
    }

    _createClass(MDDLoader, [{
      key: "load",
      value: function load(url, onLoad, onProgress, onError) {
        var scope = this;
        var loader = new _three.FileLoader(this.manager);
        loader.setPath(this.path);
        loader.setResponseType('arraybuffer');
        loader.load(url, function (data) {
          onLoad(scope.parse(data));
        }, onProgress, onError);
      }
    }, {
      key: "parse",
      value: function parse(data) {
        var view = new DataView(data);
        var totalFrames = view.getUint32(0);
        var totalPoints = view.getUint32(4);
        var offset = 8; // animation clip

        var times = new Float32Array(totalFrames);
        var values = new Float32Array(totalFrames * totalFrames).fill(0);

        for (var i = 0; i < totalFrames; i++) {
          times[i] = view.getFloat32(offset);
          offset += 4;
          values[totalFrames * i + i] = 1;
        }

        var track = new _three.NumberKeyframeTrack('.morphTargetInfluences', times, values);
        var clip = new _three.AnimationClip('default', times[times.length - 1], [track]); // morph targets

        var morphTargets = [];

        for (var _i = 0; _i < totalFrames; _i++) {
          var morphTarget = new Float32Array(totalPoints * 3);

          for (var j = 0; j < totalPoints; j++) {
            var stride = j * 3;
            morphTarget[stride + 0] = view.getFloat32(offset);
            offset += 4; // x

            morphTarget[stride + 1] = view.getFloat32(offset);
            offset += 4; // y

            morphTarget[stride + 2] = view.getFloat32(offset);
            offset += 4; // z
          }

          var attribute = new _three.BufferAttribute(morphTarget, 3);
          attribute.name = 'morph_' + _i;
          morphTargets.push(attribute);
        }

        return {
          morphTargets: morphTargets,
          clip: clip
        };
      }
    }]);

    return MDDLoader;
  }(_three.Loader);

  _exports.MDDLoader = MDDLoader;
});
