(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../loaders/GLTFLoader.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../loaders/GLTFLoader.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.GLTFLoader);
    global.VRMLoader = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _GLTFLoader) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.VRMLoader = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  // VRM Specification: https://dwango.github.io/vrm/vrm_spec/
  //
  // VRM is based on glTF 2.0 and VRM extension is defined
  // in top-level json.extensions.VRM
  var VRMLoader = /*#__PURE__*/function (_Loader) {
    _inherits(VRMLoader, _Loader);

    var _super = _createSuper(VRMLoader);

    function VRMLoader(manager) {
      var _this;

      _classCallCheck(this, VRMLoader);

      if (_GLTFLoader.GLTFLoader === undefined) {
        throw new Error('THREE.VRMLoader: Import GLTFLoader.');
      }

      _this = _super.call(this, manager);
      _this.gltfLoader = new _GLTFLoader.GLTFLoader(manager);
      return _this;
    }

    _createClass(VRMLoader, [{
      key: "load",
      value: function load(url, onLoad, onProgress, onError) {
        var scope = this;
        this.gltfLoader.load(url, function (gltf) {
          try {
            scope.parse(gltf, onLoad);
          } catch (e) {
            if (onError) {
              onError(e);
            } else {
              console.error(e);
            }

            scope.manager.itemError(url);
          }
        }, onProgress, onError);
      }
    }, {
      key: "setDRACOLoader",
      value: function setDRACOLoader(dracoLoader) {
        this.gltfLoader.setDRACOLoader(dracoLoader);
        return this;
      }
    }, {
      key: "parse",
      value: function parse(gltf, onLoad) {
        // const gltfParser = gltf.parser;
        // const gltfExtensions = gltf.userData.gltfExtensions || {};
        // const vrmExtension = gltfExtensions.VRM || {};
        // handle VRM Extension here
        onLoad(gltf);
      }
    }]);

    return VRMLoader;
  }(_three.Loader);

  _exports.VRMLoader = VRMLoader;
});
