(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../libs/flow.module.js", "../../renderers/nodes/Nodes.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../libs/flow.module.js"), require("../../renderers/nodes/Nodes.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.flowModule, global.Nodes);
    global.ColorEditor = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _flowModule, _Nodes) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ColorEditor = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var ColorEditor = /*#__PURE__*/function (_ObjectNode) {
    _inherits(ColorEditor, _ObjectNode);

    var _super = _createSuper(ColorEditor);

    function ColorEditor() {
      var _this;

      _classCallCheck(this, ColorEditor);

      var node = new _Nodes.ColorNode();
      _this = _super.call(this, 'Color', 1, node);

      _this.title.setIcon('ti ti-palette');

      var updateFields = function updateFields(editing) {
        var value = node.value;
        var hexValue = value.getHex();

        if (editing !== 'color') {
          field.setValue(hexValue, false);
        }

        if (editing !== 'hex') {
          hexField.setValue('#' + hexValue.toString(16).toUpperCase().padEnd(6, '0'), false);
        }

        if (editing !== 'rgb') {
          fieldR.setValue(value.r.toFixed(3), false);
          fieldG.setValue(value.g.toFixed(3), false);
          fieldB.setValue(value.b.toFixed(3), false);
        }
      };

      var field = new _flowModule.ColorInput(0xFFFFFF).onChange(function () {
        node.value.setHex(field.getValue());
        updateFields('picker');
      });
      var hexField = new _flowModule.StringInput().onChange(function () {
        var value = hexField.getValue();

        if (value.indexOf('#') === 0) {
          var hexStr = value.substr(1).padEnd(6, '0');
          node.value.setHex(parseInt(hexStr, 16));
          updateFields('hex');
        }
      });
      hexField.addEventListener('blur', function () {
        updateFields();
      });

      var onChangeRGB = function onChangeRGB() {
        node.value.setRGB(fieldR.getValue(), fieldG.getValue(), fieldB.getValue());
        updateFields('rgb');
      };

      var fieldR = new _flowModule.NumberInput(1, 0, 1).onChange(onChangeRGB);
      var fieldG = new _flowModule.NumberInput(1, 0, 1).onChange(onChangeRGB);
      var fieldB = new _flowModule.NumberInput(1, 0, 1).onChange(onChangeRGB);

      _this.add(new _flowModule.LabelElement('Value').add(field).setSerializable(false)).add(new _flowModule.LabelElement('Hex').add(hexField).setSerializable(false)).add(new _flowModule.LabelElement('RGB').add(fieldR).add(fieldG).add(fieldB));

      updateFields();
      return _this;
    }

    return _createClass(ColorEditor);
  }(_flowModule.ObjectNode);

  _exports.ColorEditor = ColorEditor;
});
