(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../libs/flow.module.js", "../../renderers/nodes/Nodes.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../libs/flow.module.js"), require("../../renderers/nodes/Nodes.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.flowModule, global.Nodes);
    global.Vector2Editor = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _flowModule, _Nodes) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Vector2Editor = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var Vector2Editor = /*#__PURE__*/function (_ObjectNode) {
    _inherits(Vector2Editor, _ObjectNode);

    var _super = _createSuper(Vector2Editor);

    function Vector2Editor() {
      var _this;

      _classCallCheck(this, Vector2Editor);

      var node = new _Nodes.Vector2Node();
      _this = _super.call(this, 'Vector 2', 2, node);

      _this.title.setIcon('ti ti-box-multiple-2');

      var onUpdate = function onUpdate() {
        node.value.x = fieldX.getValue();
        node.value.y = fieldY.getValue();
      };

      var fieldX = new _flowModule.NumberInput().onChange(onUpdate);
      var fieldY = new _flowModule.NumberInput().onChange(onUpdate);

      _this.add(new _flowModule.LabelElement('Values').add(fieldX).add(fieldY));

      return _this;
    }

    return _createClass(Vector2Editor);
  }(_flowModule.ObjectNode);

  _exports.Vector2Editor = Vector2Editor;
});
