(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../libs/flow.module.js", "../../renderers/nodes/Nodes.js", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../libs/flow.module.js"), require("../../renderers/nodes/Nodes.js"), require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.flowModule, global.Nodes, global.three);
    global.StandardMaterialEditor = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _flowModule, _Nodes, THREE) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.StandardMaterialEditor = void 0;
  THREE = _interopRequireWildcard(THREE);

  function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

  function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NULL_COLOR = new _Nodes.ColorNode();
  var NULL_FLOAT = new _Nodes.FloatNode();

  var StandardMaterialEditor = /*#__PURE__*/function (_ObjectNode) {
    _inherits(StandardMaterialEditor, _ObjectNode);

    var _super = _createSuper(StandardMaterialEditor);

    function StandardMaterialEditor() {
      var _this;

      _classCallCheck(this, StandardMaterialEditor);

      var material = new _Nodes.MeshStandardNodeMaterial();
      _this = _super.call(this, 'Standard Material', 0, material);

      _this.title.setStyle('blue');

      _this.setWidth(300);

      var color = new _flowModule.LabelElement('color').setInput(3);
      var opacity = new _flowModule.LabelElement('opacity').setInput(1);
      var metalness = new _flowModule.LabelElement('metalness').setInput(1);
      var roughness = new _flowModule.LabelElement('roughness').setInput(1);
      color.onConnect(function () {
        return _this.update();
      }, true);
      opacity.onConnect(function () {
        return _this.update();
      }, true);
      metalness.onConnect(function () {
        return _this.update();
      }, true);
      roughness.onConnect(function () {
        return _this.update();
      }, true);

      _this.add(color).add(opacity).add(metalness).add(roughness);

      _this.color = color;
      _this.opacity = opacity;
      _this.metalness = metalness;
      _this.roughness = roughness;
      _this.material = material;

      _this.update();

      return _this;
    }

    _createClass(StandardMaterialEditor, [{
      key: "update",
      value: function update() {
        var material = this.material,
            color = this.color,
            opacity = this.opacity,
            roughness = this.roughness,
            metalness = this.metalness;
        material.colorNode = color.linkedExtra || NULL_COLOR;
        material.opacityNode = opacity.linkedExtra || null;
        material.transparent = opacity.linkedExtra ? true : false;
        material.metalnessNode = metalness.linkedExtra || NULL_FLOAT;
        material.roughnessNode = roughness.linkedExtra || NULL_FLOAT;
        material.dispose(); // TODO: Fix on NodeMaterial System

        material.customProgramCacheKey = function () {
          return THREE.MathUtils.generateUUID();
        };
      }
    }]);

    return StandardMaterialEditor;
  }(_flowModule.ObjectNode);

  _exports.StandardMaterialEditor = StandardMaterialEditor;
});
