(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../libs/flow.module.js", "../../renderers/nodes/Nodes.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../libs/flow.module.js"), require("../../renderers/nodes/Nodes.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.flowModule, global.Nodes);
    global.OperatorEditor = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _flowModule, _Nodes) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.OperatorEditor = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NULL_VALUE = new _Nodes.FloatNode();

  var OperatorEditor = /*#__PURE__*/function (_ObjectNode) {
    _inherits(OperatorEditor, _ObjectNode);

    var _super = _createSuper(OperatorEditor);

    function OperatorEditor() {
      var _this;

      _classCallCheck(this, OperatorEditor);

      var node = new _Nodes.OperatorNode('+', NULL_VALUE, NULL_VALUE);
      _this = _super.call(this, 'Operator', 1, node, 250);
      var opInput = new _flowModule.SelectInput([{
        name: '+ Addition',
        value: '+'
      }, {
        name: '- Subtraction',
        value: '-'
      }, {
        name: '* Multiplication',
        value: '*'
      }, {
        name: '/ Division',
        value: '/'
      }]);
      opInput.onChange(function (data) {
        node.op = data.getValue();

        _this.invalidate();
      });
      var aElement = new _flowModule.LabelElement('A').setInput(3);
      var bElement = new _flowModule.LabelElement('B').setInput(3);
      aElement.onConnect(function () {
        node.aNode = aElement.linkedExtra || NULL_VALUE;
      });
      bElement.onConnect(function () {
        node.bNode = bElement.linkedExtra || NULL_VALUE;
      });

      _this.add(new _flowModule.LabelElement('Operator').add(opInput)).add(aElement).add(bElement);

      return _this;
    }

    return _createClass(OperatorEditor);
  }(_flowModule.ObjectNode);

  _exports.OperatorEditor = OperatorEditor;
});
