(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../libs/flow.module.js", "../../renderers/nodes/Nodes.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../libs/flow.module.js"), require("../../renderers/nodes/Nodes.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.flowModule, global.Nodes);
    global.TimerEditor = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _flowModule, _Nodes) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TimerEditor = void 0;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var TimerEditor = /*#__PURE__*/function (_ObjectNode) {
    _inherits(TimerEditor, _ObjectNode);

    var _super = _createSuper(TimerEditor);

    function TimerEditor() {
      var _this;

      _classCallCheck(this, TimerEditor);

      var node = new _Nodes.TimerNode();
      _this = _super.call(this, 'Timer', 1, node, 250);

      _this.title.setIcon('ti ti-clock');

      var updateField = function updateField() {
        field.setValue(node.value.toFixed(3));
      };

      var field = new _flowModule.NumberInput().onChange(function () {
        node.value = field.getValue();
      });
      var scaleField = new _flowModule.NumberInput(1).onChange(function () {
        node.scale = scaleField.getValue();
      });
      var moreElement = new _flowModule.Element().add(new _flowModule.ButtonInput('Reset').onClick(function () {
        node.value = 0;
        updateField();
      })).setSerializable(false);

      _this.add(new _flowModule.LabelElement('Value').add(field).setSerializable(false)).add(new _flowModule.LabelElement('Scale').add(scaleField)).add(moreElement); // extends node


      node._update = node.update;

      node.update = function () {
        this._update.apply(this, arguments);

        updateField();
      };

      return _this;
    }

    return _createClass(TimerEditor);
  }(_flowModule.ObjectNode);

  _exports.TimerEditor = TimerEditor;
});
