(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "../core/NodeLib.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("../core/NodeLib.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.NodeLib);
    global.NormalNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _NodeLib) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NormalNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NormalNode = /*#__PURE__*/function (_TempNode) {
    _inherits(NormalNode, _TempNode);

    var _super = _createSuper(NormalNode);

    function NormalNode(scope) {
      var _this;

      _classCallCheck(this, NormalNode);

      _this = _super.call(this, 'v3');
      _this.scope = scope || NormalNode.VIEW;
      return _this;
    }

    _createClass(NormalNode, [{
      key: "getShared",
      value: function getShared() {
        // if shared is false, TempNode will not create temp variable (for optimization)
        return this.scope === NormalNode.WORLD;
      }
    }, {
      key: "build",
      value: function build(builder, output, uuid, ns) {
        var contextNormal = builder.context[this.scope + 'Normal'];

        if (contextNormal) {
          return contextNormal.build(builder, output, uuid, ns);
        }

        return _get(_getPrototypeOf(NormalNode.prototype), "build", this).call(this, builder, output, uuid);
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var result;

        switch (this.scope) {
          case NormalNode.VIEW:
            if (builder.isShader('vertex')) result = 'transformedNormal';else result = 'geometryNormal';
            break;

          case NormalNode.LOCAL:
            if (builder.isShader('vertex')) {
              result = 'objectNormal';
            } else {
              builder.requires.normal = true;
              result = 'vObjectNormal';
            }

            break;

          case NormalNode.WORLD:
            if (builder.isShader('vertex')) {
              result = 'inverseTransformDirection( transformedNormal, viewMatrix ).xyz';
            } else {
              builder.requires.worldNormal = true;
              result = 'vWNormal';
            }

            break;
        }

        return builder.format(result, this.getType(builder), output);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(NormalNode.prototype), "copy", this).call(this, source);

        this.scope = source.scope;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.scope = this.scope;
        }

        return data;
      }
    }]);

    return NormalNode;
  }(_TempNode2.TempNode);

  _exports.NormalNode = NormalNode;
  NormalNode.LOCAL = 'local';
  NormalNode.WORLD = 'world';
  NormalNode.VIEW = 'view';
  NormalNode.prototype.nodeType = 'Normal';

  _NodeLib.NodeLib.addKeyword('viewNormal', function () {
    return new NormalNode(NormalNode.VIEW);
  });

  _NodeLib.NodeLib.addKeyword('localNormal', function () {
    return new NormalNode(NormalNode.NORMAL);
  });

  _NodeLib.NodeLib.addKeyword('worldNormal', function () {
    return new NormalNode(NormalNode.WORLD);
  });
});
