(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "../core/NodeLib.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("../core/NodeLib.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.NodeLib);
    global.PositionNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _NodeLib) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.PositionNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var PositionNode = /*#__PURE__*/function (_TempNode) {
    _inherits(PositionNode, _TempNode);

    var _super = _createSuper(PositionNode);

    function PositionNode(scope) {
      var _this;

      _classCallCheck(this, PositionNode);

      _this = _super.call(this, 'v3');
      _this.scope = scope || PositionNode.LOCAL;
      return _this;
    }

    _createClass(PositionNode, [{
      key: "getType",
      value: function getType() {
        switch (this.scope) {
          case PositionNode.PROJECTION:
            return 'v4';
        }

        return this.type;
      }
    }, {
      key: "getShared",
      value: function
        /* builder */
      getShared() {
        switch (this.scope) {
          case PositionNode.LOCAL:
          case PositionNode.WORLD:
            return false;
        }

        return true;
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var result;

        switch (this.scope) {
          case PositionNode.LOCAL:
            if (builder.isShader('vertex')) {
              result = 'transformed';
            } else {
              builder.requires.position = true;
              result = 'vPosition';
            }

            break;

          case PositionNode.WORLD:
            if (builder.isShader('vertex')) {
              return '( modelMatrix * vec4( transformed, 1.0 ) ).xyz';
            } else {
              builder.requires.worldPosition = true;
              result = 'vWPosition';
            }

            break;

          case PositionNode.VIEW:
            result = builder.isShader('vertex') ? '-mvPosition.xyz' : 'vViewPosition';
            break;

          case PositionNode.PROJECTION:
            result = builder.isShader('vertex') ? '( projectionMatrix * modelViewMatrix * vec4( position, 1.0 ) )' : 'vec4( 0.0 )';
            break;
        }

        return builder.format(result, this.getType(builder), output);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(PositionNode.prototype), "copy", this).call(this, source);

        this.scope = source.scope;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.scope = this.scope;
        }

        return data;
      }
    }]);

    return PositionNode;
  }(_TempNode2.TempNode);

  _exports.PositionNode = PositionNode;
  PositionNode.LOCAL = 'local';
  PositionNode.WORLD = 'world';
  PositionNode.VIEW = 'view';
  PositionNode.PROJECTION = 'projection';
  PositionNode.prototype.nodeType = 'Position';

  _NodeLib.NodeLib.addKeyword('position', function () {
    return new PositionNode();
  });

  _NodeLib.NodeLib.addKeyword('worldPosition', function () {
    return new PositionNode(PositionNode.WORLD);
  });

  _NodeLib.NodeLib.addKeyword('viewPosition', function () {
    return new PositionNode(PositionNode.VIEW);
  });
});
