(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "./PositionNode.js", "./NormalNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("./PositionNode.js"), require("./NormalNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.PositionNode, global.NormalNode);
    global.ReflectNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _PositionNode, _NormalNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ReflectNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var ReflectNode = /*#__PURE__*/function (_TempNode) {
    _inherits(ReflectNode, _TempNode);

    var _super = _createSuper(ReflectNode);

    function ReflectNode(scope) {
      var _this;

      _classCallCheck(this, ReflectNode);

      _this = _super.call(this, 'v3');
      _this.scope = scope || ReflectNode.CUBE;
      return _this;
    }

    _createClass(ReflectNode, [{
      key: "getUnique",
      value: function getUnique(builder) {
        return !builder.context.viewNormal;
      }
    }, {
      key: "getType",
      value: function
        /* builder */
      getType() {
        switch (this.scope) {
          case ReflectNode.SPHERE:
            return 'v2';
        }

        return this.type;
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var isUnique = this.getUnique(builder);

        if (builder.isShader('fragment')) {
          var result, code, reflectVec;

          switch (this.scope) {
            case ReflectNode.VECTOR:
              var viewNormalNode = new _NormalNode.NormalNode(_NormalNode.NormalNode.VIEW);
              var roughnessNode = builder.context.roughness;
              var viewNormal = viewNormalNode.build(builder, 'v3');
              var viewPosition = new _PositionNode.PositionNode(_PositionNode.PositionNode.VIEW).build(builder, 'v3');
              var roughness = roughnessNode ? roughnessNode.build(builder, 'f') : undefined;
              var method = "reflect( -normalize( ".concat(viewPosition, " ), ").concat(viewNormal, " )");

              if (roughness) {
                // Mixing the reflection with the normal is more accurate and keeps rough objects from gathering light from behind their tangent plane.
                method = "normalize( mix( ".concat(method, ", ").concat(viewNormal, ", ").concat(roughness, " * ").concat(roughness, " ) )");
              }

              code = "inverseTransformDirection( ".concat(method, ", viewMatrix )");

              if (isUnique) {
                builder.addNodeCode("vec3 reflectVec = ".concat(code, ";"));
                result = 'reflectVec';
              } else {
                result = code;
              }

              break;

            case ReflectNode.CUBE:
              reflectVec = new ReflectNode(ReflectNode.VECTOR).build(builder, 'v3');
              code = 'vec3( -' + reflectVec + '.x, ' + reflectVec + '.yz )';

              if (isUnique) {
                builder.addNodeCode("vec3 reflectCubeVec = ".concat(code, ";"));
                result = 'reflectCubeVec';
              } else {
                result = code;
              }

              break;

            case ReflectNode.SPHERE:
              reflectVec = new ReflectNode(ReflectNode.VECTOR).build(builder, 'v3');
              code = 'normalize( ( viewMatrix * vec4( ' + reflectVec + ', 0.0 ) ).xyz + vec3( 0.0, 0.0, 1.0 ) ).xy * 0.5 + 0.5';

              if (isUnique) {
                builder.addNodeCode("vec2 reflectSphereVec = ".concat(code, ";"));
                result = 'reflectSphereVec';
              } else {
                result = code;
              }

              break;
          }

          return builder.format(result, this.getType(builder), output);
        } else {
          console.warn('THREE.ReflectNode is not compatible with ' + builder.shader + ' shader.');
          return builder.format('vec3( 0.0 )', this.type, output);
        }
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.scope = this.scope;
        }

        return data;
      }
    }]);

    return ReflectNode;
  }(_TempNode2.TempNode);

  _exports.ReflectNode = ReflectNode;
  ReflectNode.CUBE = 'cube';
  ReflectNode.SPHERE = 'sphere';
  ReflectNode.VECTOR = 'vector';
  ReflectNode.prototype.nodeType = 'Reflect';
});
