(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./TempNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./TempNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode);
    global.ConstNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ConstNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var declarationRegexp = /^([a-z_0-9]+)\s([a-z_0-9]+)\s?\=?\s?(.*?)(\;|$)/i;

  var ConstNode = /*#__PURE__*/function (_TempNode) {
    _inherits(ConstNode, _TempNode);

    var _super = _createSuper(ConstNode);

    function ConstNode(src, useDefine) {
      var _this;

      _classCallCheck(this, ConstNode);

      _this = _super.call(this);

      _this.parse(src || ConstNode.PI, useDefine);

      return _this;
    }

    _createClass(ConstNode, [{
      key: "getType",
      value: function getType(builder) {
        return builder.getTypeByFormat(this.type);
      }
    }, {
      key: "parse",
      value: function parse(src, useDefine) {
        this.src = src || '';
        var name,
            type,
            value = '';
        var match = this.src.match(declarationRegexp);
        this.useDefine = useDefine || this.src.charAt(0) === '#';

        if (match && match.length > 1) {
          type = match[1];
          name = match[2];
          value = match[3];
        } else {
          name = this.src;
          type = 'f';
        }

        this.name = name;
        this.type = type;
        this.value = value;
      }
    }, {
      key: "build",
      value: function build(builder, output) {
        if (output === 'source') {
          if (this.value) {
            if (this.useDefine) {
              return '#define ' + this.name + ' ' + this.value;
            }

            return 'const ' + this.type + ' ' + this.name + ' = ' + this.value + ';';
          } else if (this.useDefine) {
            return this.src;
          }
        } else {
          builder.include(this);
          return builder.format(this.name, this.getType(builder), output);
        }
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        return builder.format(this.name, this.getType(builder), output);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(ConstNode.prototype), "copy", this).call(this, source);

        this.parse(source.src, source.useDefine);
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.src = this.src;
          if (data.useDefine === true) data.useDefine = true;
        }

        return data;
      }
    }]);

    return ConstNode;
  }(_TempNode2.TempNode);

  _exports.ConstNode = ConstNode;
  ConstNode.prototype.nodeType = 'Const';
  ConstNode.PI = 'PI';
  ConstNode.PI2 = 'PI2';
  ConstNode.RECIPROCAL_PI = 'RECIPROCAL_PI';
  ConstNode.RECIPROCAL_PI2 = 'RECIPROCAL_PI2';
  ConstNode.LOG2 = 'LOG2';
  ConstNode.EPSILON = 'EPSILON';
});
