(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.NodeFrame = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NodeFrame = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var NodeFrame = /*#__PURE__*/function () {
    function NodeFrame(time) {
      _classCallCheck(this, NodeFrame);

      this.time = time !== undefined ? time : 0;
      this.id = 0;
    }

    _createClass(NodeFrame, [{
      key: "update",
      value: function update(delta) {
        ++this.id;
        this.time += delta;
        this.delta = delta;
        return this;
      }
    }, {
      key: "setRenderer",
      value: function setRenderer(renderer) {
        this.renderer = renderer;
        return this;
      }
    }, {
      key: "setRenderTexture",
      value: function setRenderTexture(renderTexture) {
        this.renderTexture = renderTexture;
        return this;
      }
    }, {
      key: "updateNode",
      value: function updateNode(node) {
        if (node.frameId === this.id) return this;
        node.updateFrame(this);
        node.frameId = this.id;
        return this;
      }
    }]);

    return NodeFrame;
  }();

  _exports.NodeFrame = NodeFrame;
});
