(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.NodeLib = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NodeLib = void 0;
  var NodeLib = {
    nodes: {},
    keywords: {},
    add: function add(node) {
      this.nodes[node.name] = node;
    },
    addKeyword: function addKeyword(name, callback, cache) {
      cache = cache !== undefined ? cache : true;
      this.keywords[name] = {
        callback: callback,
        cache: cache
      };
    },
    remove: function remove(node) {
      delete this.nodes[node.name];
    },
    removeKeyword: function removeKeyword(name) {
      delete this.keywords[name];
    },
    get: function get(name) {
      return this.nodes[name];
    },
    getKeyword: function getKeyword(name, builder) {
      return this.keywords[name].callback.call(this, builder);
    },
    getKeywordData: function getKeywordData(name) {
      return this.keywords[name];
    },
    contains: function contains(name) {
      return this.nodes[name] !== undefined;
    },
    containsKeyword: function containsKeyword(name) {
      return this.keywords[name] !== undefined;
    }
  };
  _exports.NodeLib = NodeLib;
});
