(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./TempNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./TempNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode);
    global.StructNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.StructNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var declarationRegexp = /^struct\s*([a-z_0-9]+)\s*{\s*((.|\n)*?)}/img,
      propertiesRegexp = /\s*(\w*?)\s*(\w*?)(\=|\;)/img;

  var StructNode = /*#__PURE__*/function (_TempNode) {
    _inherits(StructNode, _TempNode);

    var _super = _createSuper(StructNode);

    function StructNode(src) {
      var _this;

      _classCallCheck(this, StructNode);

      _this = _super.call(this);

      _this.parse(src);

      return _this;
    }

    _createClass(StructNode, [{
      key: "getType",
      value: function getType(builder) {
        return builder.getTypeByFormat(this.name);
      }
    }, {
      key: "getInputByName",
      value: function getInputByName(name) {
        var i = this.inputs.length;

        while (i--) {
          if (this.inputs[i].name === name) {
            return this.inputs[i];
          }
        }
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        if (output === 'source') {
          return this.src + ';';
        } else {
          return builder.format('( ' + this.src + ' )', this.getType(builder), output);
        }
      }
    }, {
      key: "parse",
      value: function parse() {
        var src = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        this.src = src;
        this.inputs = [];
        var declaration = declarationRegexp.exec(this.src);

        if (declaration) {
          var properties = declaration[2];
          var match;

          while (match = propertiesRegexp.exec(properties)) {
            this.inputs.push({
              type: match[1],
              name: match[2]
            });
          }

          this.name = declaration[1];
        } else {
          this.name = '';
        }

        this.type = this.name;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.src = this.src;
        }

        return data;
      }
    }]);

    return StructNode;
  }(_TempNode2.TempNode);

  _exports.StructNode = StructNode;
  StructNode.prototype.nodeType = 'Struct';
});
