(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "./Node.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("./Node.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.Node);
    global.TempNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _Node2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TempNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var TempNode = /*#__PURE__*/function (_Node) {
    _inherits(TempNode, _Node);

    var _super = _createSuper(TempNode);

    function TempNode(type) {
      var _this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _classCallCheck(this, TempNode);

      _this = _super.call(this, type);
      _this.shared = params.shared !== undefined ? params.shared : true;
      _this.unique = params.unique !== undefined ? params.unique : false;
      return _this;
    }

    _createClass(TempNode, [{
      key: "build",
      value: function build(builder, output, uuid, ns) {
        output = output || this.getType(builder);

        if (this.getShared(builder, output)) {
          var isUnique = this.getUnique(builder, output);

          if (isUnique && this.constructor.uuid === undefined) {
            this.constructor.uuid = _three.MathUtils.generateUUID();
          }

          uuid = builder.getUuid(uuid || this.getUuid(), !isUnique);
          var data = builder.getNodeData(uuid),
              type = data.output || this.getType(builder);

          if (builder.analyzing) {
            if ((data.deps || 0) > 0 || this.getLabel()) {
              this.appendDepsNode(builder, data, output);
              return this.generate(builder, output, uuid);
            }

            return _get(_getPrototypeOf(TempNode.prototype), "build", this).call(this, builder, output, uuid);
          } else if (isUnique) {
            data.name = data.name || _get(_getPrototypeOf(TempNode.prototype), "build", this).call(this, builder, output, uuid);
            return data.name;
          } else if (!this.getLabel() && (!this.getShared(builder, type) || builder.context.ignoreCache || data.deps === 1)) {
            return _get(_getPrototypeOf(TempNode.prototype), "build", this).call(this, builder, output, uuid);
          }

          uuid = this.getUuid(false);
          var name = this.getTemp(builder, uuid);

          if (name) {
            return builder.format(name, type, output);
          } else {
            name = TempNode.prototype.generate.call(this, builder, output, uuid, data.output, ns);
            var code = this.generate(builder, type, uuid);
            builder.addNodeCode(name + ' = ' + code + ';');
            return builder.format(name, type, output);
          }
        }

        return _get(_getPrototypeOf(TempNode.prototype), "build", this).call(this, builder, output, uuid);
      }
    }, {
      key: "getShared",
      value: function getShared(builder, output) {
        return output !== 'sampler2D' && output !== 'samplerCube' && this.shared;
      }
    }, {
      key: "getUnique",
      value: function
        /* builder, output */
      getUnique() {
        return this.unique;
      }
    }, {
      key: "setLabel",
      value: function setLabel(name) {
        this.label = name;
        return this;
      }
    }, {
      key: "getLabel",
      value: function
        /* builder */
      getLabel() {
        return this.label;
      }
    }, {
      key: "getUuid",
      value: function getUuid(unique) {
        var uuid = unique || unique == undefined ? this.constructor.uuid || this.uuid : this.uuid;
        if (typeof this.scope === 'string') uuid = this.scope + '-' + uuid;
        return uuid;
      }
    }, {
      key: "getTemp",
      value: function getTemp(builder, uuid) {
        uuid = uuid || this.uuid;
        var tempVar = builder.getVars()[uuid];
        return tempVar ? tempVar.name : undefined;
      }
    }, {
      key: "generate",
      value: function generate(builder, output, uuid, type, ns) {
        if (!this.getShared(builder, output)) console.error('THREE.TempNode is not shared!');
        uuid = uuid || this.uuid;
        return builder.getTempVar(uuid, type || this.getType(builder), ns, this.getLabel()).name;
      }
    }]);

    return TempNode;
  }(_Node2.Node);

  _exports.TempNode = TempNode;
});
