(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode);
    global.OperatorNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.OperatorNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var OperatorNode = /*#__PURE__*/function (_TempNode) {
    _inherits(OperatorNode, _TempNode);

    var _super = _createSuper(OperatorNode);

    function OperatorNode(a, b, op) {
      var _this;

      _classCallCheck(this, OperatorNode);

      _this = _super.call(this);
      _this.a = a;
      _this.b = b;
      _this.op = op;
      return _this;
    }

    _createClass(OperatorNode, [{
      key: "getType",
      value: function getType(builder) {
        var a = this.a.getType(builder),
            b = this.b.getType(builder);

        if (builder.isTypeMatrix(a)) {
          return 'v4';
        } else if (builder.getTypeLength(b) > builder.getTypeLength(a)) {
          // use the greater length vector
          return b;
        }

        return a;
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var type = this.getType(builder);
        var a = this.a.build(builder, type),
            b = this.b.build(builder, type);
        return builder.format('( ' + a + ' ' + this.op + ' ' + b + ' )', type, output);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(OperatorNode.prototype), "copy", this).call(this, source);

        this.a = source.a;
        this.b = source.b;
        this.op = source.op;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.a = this.a.toJSON(meta).uuid;
          data.b = this.b.toJSON(meta).uuid;
          data.op = this.op;
        }

        return data;
      }
    }]);

    return OperatorNode;
  }(_TempNode2.TempNode);

  _exports.OperatorNode = OperatorNode;
  OperatorNode.ADD = '+';
  OperatorNode.SUB = '-';
  OperatorNode.MUL = '*';
  OperatorNode.DIV = '/';
  OperatorNode.prototype.nodeType = 'Operator';
});
