(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../core/TempNode.js", "../inputs/Vector2Node.js", "../core/FunctionNode.js", "../accessors/UVNode.js", "../accessors/NormalNode.js", "../accessors/PositionNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../core/TempNode.js"), require("../inputs/Vector2Node.js"), require("../core/FunctionNode.js"), require("../accessors/UVNode.js"), require("../accessors/NormalNode.js"), require("../accessors/PositionNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.TempNode, global.Vector2Node, global.FunctionNode, global.UVNode, global.NormalNode, global.PositionNode);
    global.NormalMapNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _TempNode2, _Vector2Node, _FunctionNode, _UVNode, _NormalNode, _PositionNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NormalMapNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NormalMapNode = /*#__PURE__*/function (_TempNode) {
    _inherits(NormalMapNode, _TempNode);

    var _super = _createSuper(NormalMapNode);

    function NormalMapNode(value, scale) {
      var _this;

      _classCallCheck(this, NormalMapNode);

      _this = _super.call(this, 'v3');
      _this.value = value;
      _this.scale = scale || new _Vector2Node.Vector2Node(1, 1);
      return _this;
    }

    _createClass(NormalMapNode, [{
      key: "generate",
      value: function generate(builder, output) {
        if (builder.isShader('fragment')) {
          var perturbNormal2Arb = builder.include(NormalMapNode.Nodes.perturbNormal2Arb);
          this.normal = this.normal || new _NormalNode.NormalNode();
          this.position = this.position || new _PositionNode.PositionNode(_PositionNode.PositionNode.VIEW);
          this.uv = this.uv || new _UVNode.UVNode();
          var scale = this.scale.build(builder, 'v2');

          if (builder.material.side === _three.BackSide) {
            scale = '-' + scale;
          }

          return builder.format(perturbNormal2Arb + '( -' + this.position.build(builder, 'v3') + ', ' + this.normal.build(builder, 'v3') + ', ' + this.value.build(builder, 'v3') + ', ' + this.uv.build(builder, 'v2') + ', ' + scale + ' )', this.getType(builder), output);
        } else {
          console.warn('THREE.NormalMapNode is not compatible with ' + builder.shader + ' shader.');
          return builder.format('vec3( 0.0 )', this.getType(builder), output);
        }
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(NormalMapNode.prototype), "copy", this).call(this, source);

        this.value = source.value;
        this.scale = source.scale;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.value = this.value.toJSON(meta).uuid;
          data.scale = this.scale.toJSON(meta).uuid;
        }

        return data;
      }
    }]);

    return NormalMapNode;
  }(_TempNode2.TempNode);

  _exports.NormalMapNode = NormalMapNode;

  NormalMapNode.Nodes = function () {
    var perturbNormal2Arb = new _FunctionNode.FunctionNode( // Per-Pixel Tangent Space Normal Mapping
    // http://hacksoflife.blogspot.ch/2009/11/per-pixel-tangent-space-normal-mapping.html
    "vec3 perturbNormal2Arb( vec3 eye_pos, vec3 surf_norm, vec3 map, vec2 vUv, vec2 normalScale ) {\n\n\t\t// Workaround for Adreno 3XX dFd*( vec3 ) bug. See #9988\n\n\t\tvec3 q0 = vec3( dFdx( eye_pos.x ), dFdx( eye_pos.y ), dFdx( eye_pos.z ) );\n\t\tvec3 q1 = vec3( dFdy( eye_pos.x ), dFdy( eye_pos.y ), dFdy( eye_pos.z ) );\n\t\tvec2 st0 = dFdx( vUv.st );\n\t\tvec2 st1 = dFdy( vUv.st );\n\n\t\tfloat scale = sign( st1.t * st0.s - st0.t * st1.s ); // we do not care about the magnitude\n\n\t\tvec3 S = normalize( ( q0 * st1.t - q1 * st0.t ) * scale );\n\t\tvec3 T = normalize( ( - q0 * st1.s + q1 * st0.s ) * scale );\n\t\tvec3 N = normalize( surf_norm );\n\n\t\tvec3 mapN = map * 2.0 - 1.0;\n\n\t\tmapN.xy *= normalScale;\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\t// Workaround for Adreno GPUs gl_FrontFacing bug. See #15850 and #10331\n\n\t\t\tif ( dot( cross( S, T ), N ) < 0.0 ) mapN.xy *= - 1.0;\n\n\t\t#else\n\n\t\t\tmapN.xy *= ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n\n\t\t#endif\n\n\t\tmat3 tsn = mat3( S, T, N );\n\t\treturn normalize( tsn * mapN );\n\n\t}", null, {
      derivatives: true
    });
    return {
      perturbNormal2Arb: perturbNormal2Arb
    };
  }();

  NormalMapNode.prototype.nodeType = 'NormalMap';
});
