(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../../postprocessing/ShaderPass.js", "../materials/NodeMaterial.js", "../inputs/ScreenNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../../postprocessing/ShaderPass.js"), require("../materials/NodeMaterial.js"), require("../inputs/ScreenNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.ShaderPass, global.NodeMaterial, global.ScreenNode);
    global.NodePass = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _ShaderPass2, _NodeMaterial, _ScreenNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NodePass = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NodePass = /*#__PURE__*/function (_ShaderPass) {
    _inherits(NodePass, _ShaderPass);

    var _super = _createSuper(NodePass);

    function NodePass() {
      var _this;

      _classCallCheck(this, NodePass);

      _this = _super.call(this);
      _this.name = '';
      _this.uuid = _three.MathUtils.generateUUID();
      _this.userData = {};
      _this.textureID = 'renderTexture';
      _this.input = new _ScreenNode.ScreenNode();
      _this.material = new _NodeMaterial.NodeMaterial();
      _this.needsUpdate = true;
      return _this;
    }

    _createClass(NodePass, [{
      key: "render",
      value: function render() {
        if (this.needsUpdate) {
          this.material.dispose();
          this.material.fragment.value = this.input;
          this.needsUpdate = false;
        }

        this.uniforms = this.material.uniforms;

        _get(_getPrototypeOf(NodePass.prototype), "render", this).apply(this, arguments);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        this.input = source.input;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var isRootObject = meta === undefined || typeof meta === 'string';

        if (isRootObject) {
          meta = {
            nodes: {}
          };
        }

        if (meta && !meta.passes) meta.passes = {};

        if (!meta.passes[this.uuid]) {
          var data = {};
          data.uuid = this.uuid;
          data.type = 'NodePass';
          meta.passes[this.uuid] = data;
          if (this.name !== '') data.name = this.name;
          if (JSON.stringify(this.userData) !== '{}') data.userData = this.userData;
          data.input = this.input.toJSON(meta).uuid;
        }

        meta.pass = this.uuid;
        return meta;
      }
    }]);

    return NodePass;
  }(_ShaderPass2.ShaderPass);

  _exports.NodePass = NodePass;
});
