(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "../core/FunctionNode.js", "../core/FunctionCallNode.js", "../inputs/FloatNode.js", "../accessors/UVNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("../core/FunctionNode.js"), require("../core/FunctionCallNode.js"), require("../inputs/FloatNode.js"), require("../accessors/UVNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.FunctionNode, global.FunctionCallNode, global.FloatNode, global.UVNode);
    global.Noise2DNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _FunctionNode, _FunctionCallNode, _FloatNode, _UVNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Noise2DNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var NOISE_COMMON_SRC = "\nvec3 mod289( vec3 x ) {\n\n\treturn x - floor( x * ( 1.0 / 289.0 ) ) * 289.0;\n\n}\n\nvec4 mod289( vec4 x ) {\n\n\treturn x - floor( x * ( 1.0 / 289.0 ) ) * 289.0;\n\n}\n\nvec4 permute( vec4 x ) {\n\n\treturn mod289( ( ( x * 34.0 ) + 1.0 ) * x );\n\n}\n\nvec4 taylorInvSqrt( vec4 r ) {\n\n\treturn 1.79284291400159 - 0.85373472095314 * r;\n\n}\n\nvec2 fade( vec2 t ) {\n\n\treturn t * t * t * ( t * ( t * 6.0 - 15.0 ) + 10.0 );\n\n}\n\nvec3 fade( vec3 t ) {\n\n\treturn t * t * t * ( t * ( t * 6.0 - 15.0 ) + 10.0 );\n\n}\n".trim();
  var NOISE2D_SRC = "\nfloat noise2d( vec2 P, float amplitude, float pivot ) {\n\n\tvec4 Pi = floor(P.xyxy) + vec4(0.0, 0.0, 1.0, 1.0);\n\tvec4 Pf = fract(P.xyxy) - vec4(0.0, 0.0, 1.0, 1.0);\n\tPi = mod289(Pi); // To avoid truncation effects in permutation\n\tvec4 ix = Pi.xzxz;\n\tvec4 iy = Pi.yyww;\n\tvec4 fx = Pf.xzxz;\n\tvec4 fy = Pf.yyww;\n\n\tvec4 i = permute(permute(ix) + iy);\n\n\tvec4 gx = fract(i * (1.0 / 41.0)) * 2.0 - 1.0 ;\n\tvec4 gy = abs(gx) - 0.5 ;\n\tvec4 tx = floor(gx + 0.5);\n\tgx = gx - tx;\n\n\tvec2 g00 = vec2(gx.x,gy.x);\n\tvec2 g10 = vec2(gx.y,gy.y);\n\tvec2 g01 = vec2(gx.z,gy.z);\n\tvec2 g11 = vec2(gx.w,gy.w);\n\n\tvec4 norm = taylorInvSqrt(vec4(dot(g00, g00), dot(g01, g01), dot(g10, g10), dot(g11, g11)));\n\tg00 *= norm.x;\n\tg01 *= norm.y;\n\tg10 *= norm.z;\n\tg11 *= norm.w;\n\n\tfloat n00 = dot(g00, vec2(fx.x, fy.x));\n\tfloat n10 = dot(g10, vec2(fx.y, fy.y));\n\tfloat n01 = dot(g01, vec2(fx.z, fy.z));\n\tfloat n11 = dot(g11, vec2(fx.w, fy.w));\n\n\tvec2 fade_xy = fade(Pf.xy);\n\tvec2 n_x = mix(vec2(n00, n01), vec2(n10, n11), fade_xy.x);\n\tfloat n_xy = mix(n_x.x, n_x.y, fade_xy.y);\n\treturn 2.3 * n_xy * amplitude + pivot;\n\n}\n".trim();

  var Noise2DNode = /*#__PURE__*/function (_TempNode) {
    _inherits(Noise2DNode, _TempNode);

    var _super = _createSuper(Noise2DNode);

    function Noise2DNode() {
      var _this;

      var uv = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new _UVNode.UVNode();
      var amplitude = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _FloatNode.FloatNode(1.0);
      var pivot = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new _FloatNode.FloatNode(0.0);

      _classCallCheck(this, Noise2DNode);

      _this = _super.call(this, 'f');
      _this.uv = uv;
      _this.amplitude = amplitude;
      _this.pivot = pivot;
      return _this;
    }

    _createClass(Noise2DNode, [{
      key: "generate",
      value: function generate(builder, output) {
        var noise2d = new _FunctionCallNode.FunctionCallNode(Noise2DNode.Nodes.noise2d, [this.uv, this.amplitude, this.pivot]);
        return builder.format(noise2d.generate(builder, output), this.getType(builder), output);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(Noise2DNode.prototype), "copy", this).call(this, source);

        this.uv = source.uv;
        this.amplitude = source.amplitude;
        this.pivot = source.pivot;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.uv = this.uv.toJSON(meta).uuid;
          data.amplitude = this.amplitude.toJSON(meta).uuid;
          data.pivot = this.pivot.toJSON(meta).uuid;
        }

        return data;
      }
    }]);

    return Noise2DNode;
  }(_TempNode2.TempNode);

  _exports.Noise2DNode = Noise2DNode;
  Noise2DNode.prototype.nodeType = 'Noise2D';

  Noise2DNode.Nodes = function () {
    var noiseCommon = new _FunctionNode.FunctionNode(NOISE_COMMON_SRC);
    var noise2d = new _FunctionNode.FunctionNode(NOISE2D_SRC);
    noise2d.includes = [noiseCommon];
    return {
      noiseCommon: noiseCommon,
      noise2d: noise2d
    };
  }();
});
