(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "../core/FunctionNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("../core/FunctionNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.FunctionNode);
    global.RemapNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _FunctionNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RemapNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var REMAP_SRC = "\nfloat remap( float value, float inLow, float inHigh, float outLow, float outHigh ) {\n\n\tfloat x = ( value - inLow ) / ( inHigh - inLow );\n\treturn outLow + ( outHigh - outLow ) * x;\n\n}\n\nvec2 remap( vec2 value, vec2 inLow, vec2 inHigh, vec2 outLow, vec2 outHigh ) {\n\n\treturn vec2(\n\t\tremap( value.x, inLow.x, inHigh.x, outLow.x, outHigh.x ),\n\t\tremap( value.y, inLow.y, inHigh.y, outLow.y, outHigh.y )\n\t);\n\n}\n\nvec2 remap( vec2 value, float inLow, float inHigh, float outLow, float outHigh ) {\n\n\treturn vec2(\n\t\tremap( value.x, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.y, inLow, inHigh, outLow, outHigh )\n\t);\n\n}\n\nvec3 remap( vec3 value, vec3 inLow, vec3 inHigh, vec3 outLow, vec3 outHigh ) {\n\n\treturn vec3(\n\t\tremap( value.x, inLow.x, inHigh.x, outLow.x, outHigh.x ),\n\t\tremap( value.y, inLow.y, inHigh.y, outLow.y, outHigh.y ),\n\t\tremap( value.z, inLow.z, inHigh.z, outLow.z, outHigh.z )\n\t);\n\n}\n\nvec3 remap( vec3 value, float inLow, float inHigh, float outLow, float outHigh ) {\n\n\treturn vec3(\n\t\tremap( value.x, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.y, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.z, inLow, inHigh, outLow, outHigh )\n\t);\n\n}\n\nvec4 remap( vec4 value, vec4 inLow, vec4 inHigh, vec4 outLow, vec4 outHigh ) {\n\n\treturn vec4(\n\t\tremap( value.x, inLow.x, inHigh.x, outLow.x, outHigh.x ),\n\t\tremap( value.y, inLow.y, inHigh.y, outLow.y, outHigh.y ),\n\t\tremap( value.z, inLow.z, inHigh.z, outLow.z, outHigh.z ),\n\t\tremap( value.w, inLow.w, inHigh.w, outLow.w, outHigh.w )\n\t);\n\n}\n\nvec4 remap( vec4 value, float inLow, float inHigh, float outLow, float outHigh ) {\n\n\treturn vec4(\n\t\tremap( value.x, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.y, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.z, inLow, inHigh, outLow, outHigh ),\n\t\tremap( value.w, inLow, inHigh, outLow, outHigh )\n\t);\n\n}\n".trim();

  var RemapNode = /*#__PURE__*/function (_TempNode) {
    _inherits(RemapNode, _TempNode);

    var _super = _createSuper(RemapNode);

    function RemapNode(value, inLow, inHigh, outLow, outHigh) {
      var _this;

      _classCallCheck(this, RemapNode);

      _this = _super.call(this, 'f');
      _this.value = value;
      _this.inLow = inLow;
      _this.inHigh = inHigh;
      _this.outLow = outLow;
      _this.outHigh = outHigh;
      return _this;
    }

    _createClass(RemapNode, [{
      key: "generate",
      value: function generate(builder, output) {
        var remap = builder.include(RemapNode.Nodes.remap);
        return builder.format(remap + '( ' + [this.value.build(builder), this.inLow.build(builder), this.inHigh.build(builder), this.outLow.build(builder), this.outHigh.build(builder)].join(', ') + ' )', this.getType(builder), output);
      }
    }, {
      key: "getType",
      value: function getType(builder) {
        return this.value.getType(builder);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(RemapNode.prototype), "copy", this).call(this, source);

        this.value = source.value;
        this.inLow = source.inLow;
        this.inHigh = source.inHigh;
        this.outLow = source.outLow;
        this.outHigh = source.outHigh;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.value = this.value.toJSON(meta).uuid;
          data.inLow = this.inLow.toJSON(meta).uuid;
          data.inHigh = this.inHigh.toJSON(meta).uuid;
          data.outLow = this.outLow.toJSON(meta).uuid;
          data.outHigh = this.outHigh.toJSON(meta).uuid;
        }

        return data;
      }
    }]);

    return RemapNode;
  }(_TempNode2.TempNode);

  _exports.RemapNode = RemapNode;
  RemapNode.prototype.nodeType = 'Remap';

  RemapNode.Nodes = function () {
    return {
      remap: new _FunctionNode.FunctionNode(REMAP_SRC)
    };
  }();
});
