(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js", "../core/FunctionNode.js", "./MaxMIPLevelNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"), require("../core/FunctionNode.js"), require("./MaxMIPLevelNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode, global.FunctionNode, global.MaxMIPLevelNode);
    global.SpecularMIPLevelNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2, _FunctionNode, _MaxMIPLevelNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SpecularMIPLevelNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var SpecularMIPLevelNode = /*#__PURE__*/function (_TempNode) {
    _inherits(SpecularMIPLevelNode, _TempNode);

    var _super = _createSuper(SpecularMIPLevelNode);

    function SpecularMIPLevelNode(roughness, texture) {
      var _this;

      _classCallCheck(this, SpecularMIPLevelNode);

      _this = _super.call(this, 'f');
      _this.roughness = roughness;
      _this.texture = texture;
      _this.maxMIPLevel = undefined;
      return _this;
    }

    _createClass(SpecularMIPLevelNode, [{
      key: "setTexture",
      value: function setTexture(texture) {
        this.texture = texture;
        return this;
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        if (builder.isShader('fragment')) {
          this.maxMIPLevel = this.maxMIPLevel || new _MaxMIPLevelNode.MaxMIPLevelNode();
          this.maxMIPLevel.texture = this.texture;
          var getSpecularMIPLevel = builder.include(SpecularMIPLevelNode.Nodes.getSpecularMIPLevel);
          return builder.format(getSpecularMIPLevel + '( ' + this.roughness.build(builder, 'f') + ', ' + this.maxMIPLevel.build(builder, 'f') + ' )', this.type, output);
        } else {
          console.warn('THREE.SpecularMIPLevelNode is not compatible with ' + builder.shader + ' shader.');
          return builder.format('0.0', this.type, output);
        }
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(SpecularMIPLevelNode.prototype), "copy", this).call(this, source);

        this.texture = source.texture;
        this.roughness = source.roughness;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.texture = this.texture;
          data.roughness = this.roughness;
        }

        return data;
      }
    }]);

    return SpecularMIPLevelNode;
  }(_TempNode2.TempNode);

  _exports.SpecularMIPLevelNode = SpecularMIPLevelNode;

  SpecularMIPLevelNode.Nodes = function () {
    // taken from here: http://casual-effects.blogspot.ca/2011/08/plausible-environment-lighting-in-two.html
    var getSpecularMIPLevel = new _FunctionNode.FunctionNode(
    /* glsl */
    "\n\n\t\tfloat getSpecularMIPLevel( const in float roughness, const in float maxMIPLevelScalar ) {\n\n\t\t\tfloat sigma = PI * roughness * roughness / ( 1.0 + roughness );\n\t\t\tfloat desiredMIPLevel = maxMIPLevelScalar + log2( sigma );\n\n\t\t\treturn clamp( desiredMIPLevel, 0.0, maxMIPLevelScalar );\n\n\t\t}");
    return {
      getSpecularMIPLevel: getSpecularMIPLevel
    };
  }();

  SpecularMIPLevelNode.prototype.nodeType = 'SpecularMIPLevel';
});
