(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/Node.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/Node.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node);
    global.SwitchNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SwitchNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var SwitchNode = /*#__PURE__*/function (_Node) {
    _inherits(SwitchNode, _Node);

    var _super = _createSuper(SwitchNode);

    function SwitchNode(node, components) {
      var _this;

      _classCallCheck(this, SwitchNode);

      _this = _super.call(this);
      _this.node = node;
      _this.components = components || 'x';
      return _this;
    }

    _createClass(SwitchNode, [{
      key: "getType",
      value: function getType(builder) {
        return builder.getTypeFromLength(this.components.length);
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var type = this.node.getType(builder),
            inputLength = builder.getTypeLength(type) - 1;
        var node = this.node.build(builder, type);

        if (inputLength > 0) {
          // get max length
          var outputLength = 0;
          var components = builder.colorToVectorProperties(this.components);
          var i;
          var len = components.length;

          for (i = 0; i < len; i++) {
            outputLength = Math.max(outputLength, builder.getIndexByElement(components.charAt(i)));
          }

          if (outputLength > inputLength) outputLength = inputLength; // split

          node += '.';

          for (i = 0; i < len; i++) {
            var idx = builder.getIndexByElement(components.charAt(i));
            if (idx > outputLength) idx = outputLength;
            node += builder.getElementByIndex(idx);
          }

          return builder.format(node, this.getType(builder), output);
        } else {
          // join
          return builder.format(node, type, output);
        }
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(SwitchNode.prototype), "copy", this).call(this, source);

        this.node = source.node;
        this.components = source.components;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.node = this.node.toJSON(meta).uuid;
          data.components = this.components;
        }

        return data;
      }
    }]);

    return SwitchNode;
  }(_Node2.Node);

  _exports.SwitchNode = SwitchNode;
  SwitchNode.prototype.nodeType = 'Switch';
});
