(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../inputs/FloatNode.js", "../core/NodeLib.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../inputs/FloatNode.js"), require("../core/NodeLib.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.FloatNode, global.NodeLib);
    global.TimerNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _FloatNode2, _NodeLib) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TimerNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var TimerNode = /*#__PURE__*/function (_FloatNode) {
    _inherits(TimerNode, _FloatNode);

    var _super = _createSuper(TimerNode);

    function TimerNode(scale, scope, timeScale) {
      var _this;

      _classCallCheck(this, TimerNode);

      _this = _super.call(this);
      _this.scale = scale !== undefined ? scale : 1;
      _this.scope = scope || TimerNode.GLOBAL;
      _this.timeScale = timeScale !== undefined ? timeScale : scale !== undefined;
      return _this;
    }

    _createClass(TimerNode, [{
      key: "getReadonly",
      value: function getReadonly() {
        // never use TimerNode as readonly but aways as "uniform"
        return false;
      }
    }, {
      key: "getUnique",
      value: function getUnique() {
        // share TimerNode "uniform" input if is used on more time with others TimerNode
        return this.timeScale && (this.scope === TimerNode.GLOBAL || this.scope === TimerNode.DELTA);
      }
    }, {
      key: "updateFrame",
      value: function updateFrame(frame) {
        var scale = this.timeScale ? this.scale : 1;

        switch (this.scope) {
          case TimerNode.LOCAL:
            this.value += frame.delta * scale;
            break;

          case TimerNode.DELTA:
            this.value = frame.delta * scale;
            break;

          default:
            this.value = frame.time * scale;
        }
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(TimerNode.prototype), "copy", this).call(this, source);

        this.scope = source.scope;
        this.scale = source.scale;
        this.timeScale = source.timeScale;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = _get(_getPrototypeOf(TimerNode.prototype), "toJSON", this).call(this, meta);

        data.scope = this.scope;
        data.scale = this.scale;
        data.timeScale = this.timeScale;
        return data;
      }
    }]);

    return TimerNode;
  }(_FloatNode2.FloatNode);

  _exports.TimerNode = TimerNode;
  TimerNode.GLOBAL = 'global';
  TimerNode.LOCAL = 'local';
  TimerNode.DELTA = 'delta';
  TimerNode.prototype.nodeType = 'Timer';

  _NodeLib.NodeLib.addKeyword('time', function () {
    return new TimerNode();
  });
});
