(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/ExpressionNode.js", "../inputs/Matrix3Node.js", "../accessors/UVNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/ExpressionNode.js"), require("../inputs/Matrix3Node.js"), require("../accessors/UVNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.ExpressionNode, global.Matrix3Node, global.UVNode);
    global.UVTransformNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _ExpressionNode2, _Matrix3Node, _UVNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.UVTransformNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var UVTransformNode = /*#__PURE__*/function (_ExpressionNode) {
    _inherits(UVTransformNode, _ExpressionNode);

    var _super = _createSuper(UVTransformNode);

    function UVTransformNode(uv, position) {
      var _this;

      _classCallCheck(this, UVTransformNode);

      _this = _super.call(this, '( uvTransform * vec3( uvNode, 1 ) ).xy', 'vec2');
      _this.uv = uv || new _UVNode.UVNode();
      _this.position = position || new _Matrix3Node.Matrix3Node();
      return _this;
    }

    _createClass(UVTransformNode, [{
      key: "generate",
      value: function generate(builder, output) {
        this.keywords['uvNode'] = this.uv;
        this.keywords['uvTransform'] = this.position;
        return _get(_getPrototypeOf(UVTransformNode.prototype), "generate", this).call(this, builder, output);
      }
    }, {
      key: "setUvTransform",
      value: function setUvTransform(tx, ty, sx, sy, rotation, cx, cy) {
        cx = cx !== undefined ? cx : .5;
        cy = cy !== undefined ? cy : .5;
        this.position.value.setUvTransform(tx, ty, sx, sy, rotation, cx, cy);
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(UVTransformNode.prototype), "copy", this).call(this, source);

        this.uv = source.uv;
        this.position = source.position;
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = this.getJSONNode(meta);

        if (!data) {
          data = this.createJSONNode(meta);
          data.uv = this.uv.toJSON(meta).uuid;
          data.position = this.position.toJSON(meta).uuid;
        }

        return data;
      }
    }]);

    return UVTransformNode;
  }(_ExpressionNode2.ExpressionNode);

  _exports.UVTransformNode = UVTransformNode;
  UVTransformNode.prototype.nodeType = 'UVTransform';
});
