(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "../inputs/Vector3Node.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("../inputs/Vector3Node.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.Vector3Node);
    global.VelocityNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _Vector3Node2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.VelocityNode = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var VelocityNode = /*#__PURE__*/function (_Vector3Node) {
    _inherits(VelocityNode, _Vector3Node);

    var _super = _createSuper(VelocityNode);

    function VelocityNode(target, params) {
      var _this;

      _classCallCheck(this, VelocityNode);

      _this = _super.call(this);
      _this.params = {};
      _this.velocity = new _three.Vector3();

      _this.setTarget(target);

      _this.setParams(params);

      return _this;
    }

    _createClass(VelocityNode, [{
      key: "getReadonly",
      value: function
        /*builder*/
      getReadonly() {
        return false;
      }
    }, {
      key: "setParams",
      value: function setParams(params) {
        switch (this.params.type) {
          case 'elastic':
            delete this.moment;
            delete this.speed;
            delete this.springVelocity;
            delete this.lastVelocity;
            break;
        }

        this.params = params || {};

        switch (this.params.type) {
          case 'elastic':
            this.moment = new _three.Vector3();
            this.speed = new _three.Vector3();
            this.springVelocity = new _three.Vector3();
            this.lastVelocity = new _three.Vector3();
            break;
        }
      }
    }, {
      key: "setTarget",
      value: function setTarget(target) {
        if (this.target) {
          delete this.position;
          delete this.oldPosition;
        }

        this.target = target;

        if (target) {
          this.position = target.getWorldPosition(this.position || new _three.Vector3());
          this.oldPosition = this.position.clone();
        }
      }
    }, {
      key: "updateFrameVelocity",
      value: function
        /*frame*/
      updateFrameVelocity() {
        if (this.target) {
          this.position = this.target.getWorldPosition(this.position || new _three.Vector3());
          this.velocity.subVectors(this.position, this.oldPosition);
          this.oldPosition.copy(this.position);
        }
      }
    }, {
      key: "updateFrame",
      value: function updateFrame(frame) {
        this.updateFrameVelocity(frame);

        switch (this.params.type) {
          case 'elastic':
            // convert to real scale: 0 at 1 values
            var deltaFps = frame.delta * (this.params.fps || 60);
            var spring = Math.pow(this.params.spring, deltaFps),
                damping = Math.pow(this.params.damping, deltaFps); // fix relative frame-rate

            this.velocity.multiplyScalar(Math.exp(-this.params.damping * deltaFps)); // elastic

            this.velocity.add(this.springVelocity);
            this.velocity.add(this.speed.multiplyScalar(damping).multiplyScalar(1 - spring)); // speed

            this.speed.subVectors(this.velocity, this.lastVelocity); // spring velocity

            this.springVelocity.add(this.speed);
            this.springVelocity.multiplyScalar(spring); // moment

            this.moment.add(this.springVelocity); // damping

            this.moment.multiplyScalar(damping);
            this.lastVelocity.copy(this.velocity);
            this.value.copy(this.moment);
            break;

          default:
            this.value.copy(this.velocity);
        }
      }
    }, {
      key: "copy",
      value: function copy(source) {
        _get(_getPrototypeOf(VelocityNode.prototype), "copy", this).call(this, source);

        if (source.target) this.setTarget(source.target);
        this.setParams(source.params);
        return this;
      }
    }, {
      key: "toJSON",
      value: function toJSON(meta) {
        var data = _get(_getPrototypeOf(VelocityNode.prototype), "toJSON", this).call(this, meta);

        if (this.target) data.target = this.target.uuid; // clone params

        data.params = JSON.parse(JSON.stringify(this.params));
        return data;
      }
    }]);

    return VelocityNode;
  }(_Vector3Node2.Vector3Node);

  _exports.VelocityNode = VelocityNode;
  VelocityNode.prototype.nodeType = 'Velocity';
});
