(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.jank = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  var interval = null;
  var result = null;

  function initJank() {
    var button = document.getElementById('button');
    button.addEventListener('click', function () {
      if (interval === null) {
        interval = setInterval(jank, 1000 / 60);
        button.textContent = 'STOP JANK';
      } else {
        clearInterval(interval);
        interval = null;
        button.textContent = 'START JANK';
        result.textContent = '';
      }
    });
    result = document.getElementById('result');
  }

  function jank() {
    var number = 0;

    for (var i = 0; i < 10000000; i++) {
      number += Math.random();
    }

    result.textContent = number;
  }

  var _default = initJank;
  _exports.default = _default;
});
