(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "./Pass.js", "../shaders/AfterimageShader.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("./Pass.js"), require("../shaders/AfterimageShader.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.Pass, global.AfterimageShader);
    global.AfterimagePass = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _Pass2, _AfterimageShader) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.AfterimagePass = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var AfterimagePass = /*#__PURE__*/function (_Pass) {
    _inherits(AfterimagePass, _Pass);

    var _super = _createSuper(AfterimagePass);

    function AfterimagePass() {
      var _this;

      var damp = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0.96;

      _classCallCheck(this, AfterimagePass);

      _this = _super.call(this);
      if (_AfterimageShader.AfterimageShader === undefined) console.error('THREE.AfterimagePass relies on AfterimageShader');
      _this.shader = _AfterimageShader.AfterimageShader;
      _this.uniforms = _three.UniformsUtils.clone(_this.shader.uniforms);
      _this.uniforms['damp'].value = damp;
      _this.textureComp = new _three.WebGLRenderTarget(window.innerWidth, window.innerHeight, {
        minFilter: _three.LinearFilter,
        magFilter: _three.NearestFilter,
        format: _three.RGBAFormat
      });
      _this.textureOld = new _three.WebGLRenderTarget(window.innerWidth, window.innerHeight, {
        minFilter: _three.LinearFilter,
        magFilter: _three.NearestFilter,
        format: _three.RGBAFormat
      });
      _this.shaderMaterial = new _three.ShaderMaterial({
        uniforms: _this.uniforms,
        vertexShader: _this.shader.vertexShader,
        fragmentShader: _this.shader.fragmentShader
      });
      _this.compFsQuad = new _Pass2.FullScreenQuad(_this.shaderMaterial);
      var material = new _three.MeshBasicMaterial();
      _this.copyFsQuad = new _Pass2.FullScreenQuad(material);
      return _this;
    }

    _createClass(AfterimagePass, [{
      key: "render",
      value: function render(renderer, writeBuffer, readBuffer
      /*, deltaTime, maskActive*/
      ) {
        this.uniforms['tOld'].value = this.textureOld.texture;
        this.uniforms['tNew'].value = readBuffer.texture;
        renderer.setRenderTarget(this.textureComp);
        this.compFsQuad.render(renderer);
        this.copyFsQuad.material.map = this.textureComp.texture;

        if (this.renderToScreen) {
          renderer.setRenderTarget(null);
          this.copyFsQuad.render(renderer);
        } else {
          renderer.setRenderTarget(writeBuffer);
          if (this.clear) renderer.clear();
          this.copyFsQuad.render(renderer);
        } // Swap buffers.


        var temp = this.textureOld;
        this.textureOld = this.textureComp;
        this.textureComp = temp; // Now textureOld contains the latest image, ready for the next frame.
      }
    }, {
      key: "setSize",
      value: function setSize(width, height) {
        this.textureComp.setSize(width, height);
        this.textureOld.setSize(width, height);
      }
    }]);

    return AfterimagePass;
  }(_Pass2.Pass);

  _exports.AfterimagePass = AfterimagePass;
});
