(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three", "./Pass.js", "../shaders/DigitalGlitch.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"), require("./Pass.js"), require("../shaders/DigitalGlitch.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three, global.Pass, global.DigitalGlitch);
    global.GlitchPass = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three, _Pass2, _DigitalGlitch) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.GlitchPass = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var GlitchPass = /*#__PURE__*/function (_Pass) {
    _inherits(GlitchPass, _Pass);

    var _super = _createSuper(GlitchPass);

    function GlitchPass() {
      var _this;

      var dt_size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 64;

      _classCallCheck(this, GlitchPass);

      _this = _super.call(this);
      if (_DigitalGlitch.DigitalGlitch === undefined) console.error('THREE.GlitchPass relies on DigitalGlitch');
      var shader = _DigitalGlitch.DigitalGlitch;
      _this.uniforms = _three.UniformsUtils.clone(shader.uniforms);
      _this.uniforms['tDisp'].value = _this.generateHeightmap(dt_size);
      _this.material = new _three.ShaderMaterial({
        uniforms: _this.uniforms,
        vertexShader: shader.vertexShader,
        fragmentShader: shader.fragmentShader
      });
      _this.fsQuad = new _Pass2.FullScreenQuad(_this.material);
      _this.goWild = false;
      _this.curF = 0;

      _this.generateTrigger();

      return _this;
    }

    _createClass(GlitchPass, [{
      key: "render",
      value: function render(renderer, writeBuffer, readBuffer
      /*, deltaTime, maskActive */
      ) {
        this.uniforms['tDiffuse'].value = readBuffer.texture;
        this.uniforms['seed'].value = Math.random(); //default seeding

        this.uniforms['byp'].value = 0;

        if (this.curF % this.randX == 0 || this.goWild == true) {
          this.uniforms['amount'].value = Math.random() / 30;
          this.uniforms['angle'].value = _three.MathUtils.randFloat(-Math.PI, Math.PI);
          this.uniforms['seed_x'].value = _three.MathUtils.randFloat(-1, 1);
          this.uniforms['seed_y'].value = _three.MathUtils.randFloat(-1, 1);
          this.uniforms['distortion_x'].value = _three.MathUtils.randFloat(0, 1);
          this.uniforms['distortion_y'].value = _three.MathUtils.randFloat(0, 1);
          this.curF = 0;
          this.generateTrigger();
        } else if (this.curF % this.randX < this.randX / 5) {
          this.uniforms['amount'].value = Math.random() / 90;
          this.uniforms['angle'].value = _three.MathUtils.randFloat(-Math.PI, Math.PI);
          this.uniforms['distortion_x'].value = _three.MathUtils.randFloat(0, 1);
          this.uniforms['distortion_y'].value = _three.MathUtils.randFloat(0, 1);
          this.uniforms['seed_x'].value = _three.MathUtils.randFloat(-0.3, 0.3);
          this.uniforms['seed_y'].value = _three.MathUtils.randFloat(-0.3, 0.3);
        } else if (this.goWild == false) {
          this.uniforms['byp'].value = 1;
        }

        this.curF++;

        if (this.renderToScreen) {
          renderer.setRenderTarget(null);
          this.fsQuad.render(renderer);
        } else {
          renderer.setRenderTarget(writeBuffer);
          if (this.clear) renderer.clear();
          this.fsQuad.render(renderer);
        }
      }
    }, {
      key: "generateTrigger",
      value: function generateTrigger() {
        this.randX = _three.MathUtils.randInt(120, 240);
      }
    }, {
      key: "generateHeightmap",
      value: function generateHeightmap(dt_size) {
        var data_arr = new Float32Array(dt_size * dt_size * 3);
        var length = dt_size * dt_size;

        for (var i = 0; i < length; i++) {
          var val = _three.MathUtils.randFloat(0, 1);

          data_arr[i * 3 + 0] = val;
          data_arr[i * 3 + 1] = val;
          data_arr[i * 3 + 2] = val;
        }

        return new _three.DataTexture(data_arr, dt_size, dt_size, _three.RGBFormat, _three.FloatType);
      }
    }]);

    return GlitchPass;
  }(_Pass2.Pass);

  _exports.GlitchPass = GlitchPass;
});
