(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Pass.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Pass.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Pass);
    global.MaskPass = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Pass3) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MaskPass = _exports.ClearMaskPass = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var MaskPass = /*#__PURE__*/function (_Pass) {
    _inherits(MaskPass, _Pass);

    var _super = _createSuper(MaskPass);

    function MaskPass(scene, camera) {
      var _this;

      _classCallCheck(this, MaskPass);

      _this = _super.call(this);
      _this.scene = scene;
      _this.camera = camera;
      _this.clear = true;
      _this.needsSwap = false;
      _this.inverse = false;
      return _this;
    }

    _createClass(MaskPass, [{
      key: "render",
      value: function render(renderer, writeBuffer, readBuffer
      /*, deltaTime, maskActive */
      ) {
        var context = renderer.getContext();
        var state = renderer.state; // don't update color or depth

        state.buffers.color.setMask(false);
        state.buffers.depth.setMask(false); // lock buffers

        state.buffers.color.setLocked(true);
        state.buffers.depth.setLocked(true); // set up stencil

        var writeValue, clearValue;

        if (this.inverse) {
          writeValue = 0;
          clearValue = 1;
        } else {
          writeValue = 1;
          clearValue = 0;
        }

        state.buffers.stencil.setTest(true);
        state.buffers.stencil.setOp(context.REPLACE, context.REPLACE, context.REPLACE);
        state.buffers.stencil.setFunc(context.ALWAYS, writeValue, 0xffffffff);
        state.buffers.stencil.setClear(clearValue);
        state.buffers.stencil.setLocked(true); // draw into the stencil buffer

        renderer.setRenderTarget(readBuffer);
        if (this.clear) renderer.clear();
        renderer.render(this.scene, this.camera);
        renderer.setRenderTarget(writeBuffer);
        if (this.clear) renderer.clear();
        renderer.render(this.scene, this.camera); // unlock color and depth buffer for subsequent rendering

        state.buffers.color.setLocked(false);
        state.buffers.depth.setLocked(false); // only render where stencil is set to 1

        state.buffers.stencil.setLocked(false);
        state.buffers.stencil.setFunc(context.EQUAL, 1, 0xffffffff); // draw if == 1

        state.buffers.stencil.setOp(context.KEEP, context.KEEP, context.KEEP);
        state.buffers.stencil.setLocked(true);
      }
    }]);

    return MaskPass;
  }(_Pass3.Pass);

  _exports.MaskPass = MaskPass;

  var ClearMaskPass = /*#__PURE__*/function (_Pass2) {
    _inherits(ClearMaskPass, _Pass2);

    var _super2 = _createSuper(ClearMaskPass);

    function ClearMaskPass() {
      var _this2;

      _classCallCheck(this, ClearMaskPass);

      _this2 = _super2.call(this);
      _this2.needsSwap = false;
      return _this2;
    }

    _createClass(ClearMaskPass, [{
      key: "render",
      value: function render(renderer
      /*, writeBuffer, readBuffer, deltaTime, maskActive */
      ) {
        renderer.state.buffers.stencil.setLocked(false);
        renderer.state.buffers.stencil.setTest(false);
      }
    }]);

    return ClearMaskPass;
  }(_Pass3.Pass);

  _exports.ClearMaskPass = ClearMaskPass;
});
