(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.CSS2DRenderer = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.CSS2DRenderer = _exports.CSS2DObject = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var CSS2DObject = /*#__PURE__*/function (_Object3D) {
    _inherits(CSS2DObject, _Object3D);

    var _super = _createSuper(CSS2DObject);

    function CSS2DObject() {
      var _this2;

      var element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.createElement('div');

      _classCallCheck(this, CSS2DObject);

      _this2 = _super.call(this);
      _this2.element = element;
      _this2.element.style.position = 'absolute';
      _this2.element.style.userSelect = 'none';

      _this2.element.setAttribute('draggable', false);

      _this2.addEventListener('removed', function () {
        this.traverse(function (object) {
          if (object.element instanceof Element && object.element.parentNode !== null) {
            object.element.parentNode.removeChild(object.element);
          }
        });
      });

      return _this2;
    }

    _createClass(CSS2DObject, [{
      key: "copy",
      value: function copy(source, recursive) {
        _get(_getPrototypeOf(CSS2DObject.prototype), "copy", this).call(this, source, recursive);

        this.element = source.element.cloneNode(true);
        return this;
      }
    }]);

    return CSS2DObject;
  }(_three.Object3D);

  _exports.CSS2DObject = CSS2DObject;
  CSS2DObject.prototype.isCSS2DObject = true; //

  var _vector = new _three.Vector3();

  var _viewMatrix = new _three.Matrix4();

  var _viewProjectionMatrix = new _three.Matrix4();

  var _a = new _three.Vector3();

  var _b = new _three.Vector3();

  var CSS2DRenderer = /*#__PURE__*/_createClass(function CSS2DRenderer() {
    var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, CSS2DRenderer);

    var _this = this;

    var _width, _height;

    var _widthHalf, _heightHalf;

    var cache = {
      objects: new WeakMap()
    };
    var domElement = parameters.element !== undefined ? parameters.element : document.createElement('div');
    domElement.style.overflow = 'hidden';
    this.domElement = domElement;

    this.getSize = function () {
      return {
        width: _width,
        height: _height
      };
    };

    this.render = function (scene, camera) {
      if (scene.autoUpdate === true) scene.updateMatrixWorld();
      if (camera.parent === null) camera.updateMatrixWorld();

      _viewMatrix.copy(camera.matrixWorldInverse);

      _viewProjectionMatrix.multiplyMatrices(camera.projectionMatrix, _viewMatrix);

      renderObject(scene, scene, camera);
      zOrder(scene);
    };

    this.setSize = function (width, height) {
      _width = width;
      _height = height;
      _widthHalf = _width / 2;
      _heightHalf = _height / 2;
      domElement.style.width = width + 'px';
      domElement.style.height = height + 'px';
    };

    function renderObject(object, scene, camera) {
      if (object.isCSS2DObject) {
        object.onBeforeRender(_this, scene, camera);

        _vector.setFromMatrixPosition(object.matrixWorld);

        _vector.applyMatrix4(_viewProjectionMatrix);

        var element = object.element;

        if (/apple/i.test(navigator.vendor)) {
          // https://github.com/mrdoob/three.js/issues/21415
          element.style.transform = 'translate(-50%,-50%) translate(' + Math.round(_vector.x * _widthHalf + _widthHalf) + 'px,' + Math.round(-_vector.y * _heightHalf + _heightHalf) + 'px)';
        } else {
          element.style.transform = 'translate(-50%,-50%) translate(' + (_vector.x * _widthHalf + _widthHalf) + 'px,' + (-_vector.y * _heightHalf + _heightHalf) + 'px)';
        }

        element.style.display = object.visible && _vector.z >= -1 && _vector.z <= 1 ? '' : 'none';
        var objectData = {
          distanceToCameraSquared: getDistanceToSquared(camera, object)
        };
        cache.objects.set(object, objectData);

        if (element.parentNode !== domElement) {
          domElement.appendChild(element);
        }

        object.onAfterRender(_this, scene, camera);
      }

      for (var i = 0, l = object.children.length; i < l; i++) {
        renderObject(object.children[i], scene, camera);
      }
    }

    function getDistanceToSquared(object1, object2) {
      _a.setFromMatrixPosition(object1.matrixWorld);

      _b.setFromMatrixPosition(object2.matrixWorld);

      return _a.distanceToSquared(_b);
    }

    function filterAndFlatten(scene) {
      var result = [];
      scene.traverse(function (object) {
        if (object.isCSS2DObject) result.push(object);
      });
      return result;
    }

    function zOrder(scene) {
      var sorted = filterAndFlatten(scene).sort(function (a, b) {
        var distanceA = cache.objects.get(a).distanceToCameraSquared;
        var distanceB = cache.objects.get(b).distanceToCameraSquared;
        return distanceA - distanceB;
      });
      var zMax = sorted.length;

      for (var i = 0, l = sorted.length; i < l; i++) {
        sorted[i].element.style.zIndex = zMax - i;
      }
    }
  });

  _exports.CSS2DRenderer = CSS2DRenderer;
});
