(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Object3DNode.js", "../inputs/Matrix4Node.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Object3DNode.js"), require("../inputs/Matrix4Node.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Object3DNode, global.Matrix4Node);
    global.CameraNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Object3DNode2, _Matrix4Node) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Object3DNode2 = _interopRequireDefault(_Object3DNode2);
  _Matrix4Node = _interopRequireDefault(_Matrix4Node);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var CameraNode = /*#__PURE__*/function (_Object3DNode) {
    _inherits(CameraNode, _Object3DNode);

    var _super = _createSuper(CameraNode);

    function CameraNode() {
      var _this;

      var scope = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : CameraNode.POSITION;

      _classCallCheck(this, CameraNode);

      _this = _super.call(this, scope);
      _this._inputNode = null;
      return _this;
    }

    _createClass(CameraNode, [{
      key: "getNodeType",
      value: function getNodeType(builder) {
        var scope = this.scope;

        if (scope === CameraNode.PROJECTION_MATRIX) {
          return 'mat4';
        }

        return _get(_getPrototypeOf(CameraNode.prototype), "getNodeType", this).call(this, builder);
      }
    }, {
      key: "update",
      value: function update(frame) {
        var camera = frame.camera;
        var inputNode = this._inputNode;
        var scope = this.scope;

        if (scope === CameraNode.PROJECTION_MATRIX) {
          inputNode.value = camera.projectionMatrix;
        } else if (scope === CameraNode.VIEW_MATRIX) {
          inputNode.value = camera.matrixWorldInverse;
        } else {
          _get(_getPrototypeOf(CameraNode.prototype), "update", this).call(this, frame);
        }
      }
    }, {
      key: "generate",
      value: function generate(builder) {
        var scope = this.scope;

        if (scope === CameraNode.PROJECTION_MATRIX) {
          this._inputNode = new _Matrix4Node.default(null);
        }

        return _get(_getPrototypeOf(CameraNode.prototype), "generate", this).call(this, builder);
      }
    }]);

    return CameraNode;
  }(_Object3DNode2.default);

  _defineProperty(CameraNode, "PROJECTION_MATRIX", 'projectionMatrix');

  var _default = CameraNode;
  _exports.default = _default;
});
