(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/Node.js", "../core/AttributeNode.js", "../core/VaryNode.js", "../accessors/ModelNode.js", "../math/MathNode.js", "../math/OperatorNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/Node.js"), require("../core/AttributeNode.js"), require("../core/VaryNode.js"), require("../accessors/ModelNode.js"), require("../math/MathNode.js"), require("../math/OperatorNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node, global.AttributeNode, global.VaryNode, global.ModelNode, global.MathNode, global.OperatorNode);
    global.PositionNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2, _AttributeNode, _VaryNode, _ModelNode, _MathNode, _OperatorNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Node2 = _interopRequireDefault(_Node2);
  _AttributeNode = _interopRequireDefault(_AttributeNode);
  _VaryNode = _interopRequireDefault(_VaryNode);
  _ModelNode = _interopRequireDefault(_ModelNode);
  _MathNode = _interopRequireDefault(_MathNode);
  _OperatorNode = _interopRequireDefault(_OperatorNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var PositionNode = /*#__PURE__*/function (_Node) {
    _inherits(PositionNode, _Node);

    var _super = _createSuper(PositionNode);

    function PositionNode() {
      var _this;

      var scope = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : PositionNode.LOCAL;

      _classCallCheck(this, PositionNode);

      _this = _super.call(this, 'vec3');
      _this.scope = scope;
      return _this;
    }

    _createClass(PositionNode, [{
      key: "getHash",
      value: function
        /*builder*/
      getHash() {
        return "position-".concat(this.scope);
      }
    }, {
      key: "generate",
      value: function generate(builder) {
        var scope = this.scope;
        var outputNode = null;

        if (scope === PositionNode.GEOMETRY) {
          outputNode = new _AttributeNode.default('position', 'vec3');
        } else if (scope === PositionNode.LOCAL) {
          outputNode = new _VaryNode.default(new PositionNode(PositionNode.GEOMETRY));
        } else if (scope === PositionNode.WORLD) {
          var vertexPositionNode = new _MathNode.default(_MathNode.default.TRANSFORM_DIRECTION, new _ModelNode.default(_ModelNode.default.WORLD_MATRIX), new PositionNode(PositionNode.LOCAL));
          outputNode = new _VaryNode.default(vertexPositionNode);
        } else if (scope === PositionNode.VIEW) {
          var _vertexPositionNode = new _OperatorNode.default('*', new _ModelNode.default(_ModelNode.default.VIEW_MATRIX), new PositionNode(PositionNode.LOCAL));

          outputNode = new _VaryNode.default(_vertexPositionNode);
        } else if (scope === PositionNode.VIEW_DIRECTION) {
          var _vertexPositionNode2 = new _MathNode.default(_MathNode.default.NEGATE, new PositionNode(PositionNode.VIEW));

          outputNode = new _MathNode.default(_MathNode.default.NORMALIZE, new _VaryNode.default(_vertexPositionNode2));
        }

        return outputNode.build(builder, this.getNodeType(builder));
      }
    }]);

    return PositionNode;
  }(_Node2.default);

  _defineProperty(PositionNode, "GEOMETRY", 'geometry');

  _defineProperty(PositionNode, "LOCAL", 'local');

  _defineProperty(PositionNode, "WORLD", 'world');

  _defineProperty(PositionNode, "VIEW", 'view');

  _defineProperty(PositionNode, "VIEW_DIRECTION", 'viewDirection');

  var _default = PositionNode;
  _exports.default = _default;
});
