(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Node.js", "./VaryNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Node.js"), require("./VaryNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node, global.VaryNode);
    global.AttributeNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2, _VaryNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Node2 = _interopRequireDefault(_Node2);
  _VaryNode = _interopRequireDefault(_VaryNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var AttributeNode = /*#__PURE__*/function (_Node) {
    _inherits(AttributeNode, _Node);

    var _super = _createSuper(AttributeNode);

    function AttributeNode(attributeName, nodeType) {
      var _this;

      _classCallCheck(this, AttributeNode);

      _this = _super.call(this, nodeType);
      _this._attributeName = attributeName;
      return _this;
    }

    _createClass(AttributeNode, [{
      key: "getHash",
      value: function getHash(builder) {
        return this.getAttributeName(builder);
      }
    }, {
      key: "setAttributeName",
      value: function setAttributeName(attributeName) {
        this._attributeName = attributeName;
        return this;
      }
    }, {
      key: "getAttributeName",
      value: function
        /*builder*/
      getAttributeName() {
        return this._attributeName;
      }
    }, {
      key: "generate",
      value: function generate(builder) {
        var attribute = builder.getAttribute(this.getAttributeName(builder), this.getNodeType(builder));

        if (builder.isShaderStage('vertex')) {
          return attribute.name;
        } else {
          var nodeVary = new _VaryNode.default(this);
          return nodeVary.build(builder, attribute.type);
        }
      }
    }]);

    return AttributeNode;
  }(_Node2.default);

  var _default = AttributeNode;
  _exports.default = _default;
});
