(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./CodeNode.js", "./FunctionCallNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./CodeNode.js"), require("./FunctionCallNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.CodeNode, global.FunctionCallNode);
    global.FunctionNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _CodeNode2, _FunctionCallNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _CodeNode2 = _interopRequireDefault(_CodeNode2);
  _FunctionCallNode = _interopRequireDefault(_FunctionCallNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var FunctionNode = /*#__PURE__*/function (_CodeNode) {
    _inherits(FunctionNode, _CodeNode);

    var _super = _createSuper(FunctionNode);

    function FunctionNode() {
      var _this;

      var code = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      _classCallCheck(this, FunctionNode);

      _this = _super.call(this, code);
      _this.useKeywords = true;
      return _this;
    }

    _createClass(FunctionNode, [{
      key: "getNodeType",
      value: function getNodeType(builder) {
        return this.getNodeFunction(builder).type;
      }
    }, {
      key: "getInputs",
      value: function getInputs(builder) {
        return this.getNodeFunction(builder).inputs;
      }
    }, {
      key: "getNodeFunction",
      value: function getNodeFunction(builder) {
        var nodeData = builder.getDataFromNode(this);
        var nodeFunction = nodeData.nodeFunction;

        if (nodeFunction === undefined) {
          nodeFunction = builder.parser.parseFunction(this.code);
          nodeData.nodeFunction = nodeFunction;
        }

        return nodeFunction;
      }
    }, {
      key: "call",
      value: function call() {
        var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return new _FunctionCallNode.default(this, parameters);
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        _get(_getPrototypeOf(FunctionNode.prototype), "generate", this).call(this, builder);

        var nodeFunction = this.getNodeFunction(builder);
        var name = nodeFunction.name;
        var type = nodeFunction.type;
        var nodeCode = builder.getCodeFromNode(this, type);

        if (name !== '') {
          // use a custom property name
          nodeCode.name = name;
        }

        var propertyName = builder.getPropertyName(nodeCode);
        nodeCode.code = this.getNodeFunction(builder).getCode(propertyName);

        if (output === 'property') {
          return propertyName;
        } else {
          return builder.format("".concat(propertyName, "()"), type, output);
        }
      }
    }]);

    return FunctionNode;
  }(_CodeNode2.default);

  var _default = FunctionNode;
  _exports.default = _default;
});
