(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Node.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Node.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node);
    global.InputNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Node2 = _interopRequireDefault(_Node2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var InputNode = /*#__PURE__*/function (_Node) {
    _inherits(InputNode, _Node);

    var _super = _createSuper(InputNode);

    function InputNode(inputType) {
      var _this;

      _classCallCheck(this, InputNode);

      _this = _super.call(this, inputType);
      _this.inputType = inputType;
      _this.constant = false;
      return _this;
    }

    _createClass(InputNode, [{
      key: "setConst",
      value: function setConst(value) {
        this.constant = value;
        return this;
      }
    }, {
      key: "getConst",
      value: function getConst() {
        return this.constant;
      }
    }, {
      key: "getInputType",
      value: function getInputType(builder) {
        return this.inputType;
      }
    }, {
      key: "generateConst",
      value: function generateConst(builder) {
        return builder.getConst(this.getNodeType(builder), this.value);
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var type = this.getNodeType(builder);

        if (this.constant === true) {
          return builder.format(this.generateConst(builder), type, output);
        } else {
          var inputType = this.getInputType(builder);
          var nodeUniform = builder.getUniformFromNode(this, builder.shaderStage, inputType);
          var propertyName = builder.getPropertyName(nodeUniform);
          return builder.format(propertyName, type, output);
        }
      }
    }]);

    return InputNode;
  }(_Node2.default);

  InputNode.prototype.isInputNode = true;
  var _default = InputNode;
  _exports.default = _default;
});
