(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./constants.js", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./constants.js"), require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.constants, global.three);
    global.Node = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _constants, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var Node = /*#__PURE__*/function () {
    function Node() {
      var nodeType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      _classCallCheck(this, Node);

      this.nodeType = nodeType;
      this.updateType = _constants.NodeUpdateType.None;
      this.uuid = _three.MathUtils.generateUUID();
    }

    _createClass(Node, [{
      key: "type",
      get: function get() {
        return this.constructor.name;
      }
    }, {
      key: "getHash",
      value: function
        /*builder*/
      getHash() {
        return this.uuid;
      }
    }, {
      key: "getUpdateType",
      value: function
        /*builder*/
      getUpdateType() {
        return this.updateType;
      }
    }, {
      key: "getNodeType",
      value: function
        /*builder*/
      getNodeType() {
        return this.nodeType;
      }
    }, {
      key: "update",
      value: function
        /*frame*/
      update() {
        console.warn('Abstract function.');
      }
    }, {
      key: "generate",
      value: function
        /*builder, output*/
      generate() {
        console.warn('Abstract function.');
      }
    }, {
      key: "build",
      value: function build(builder) {
        var output = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var hash = this.getHash(builder);
        var sharedNode = builder.getNodeFromHash(hash);

        if (sharedNode !== undefined && this !== sharedNode) {
          return sharedNode.build(builder, output);
        }

        builder.addNode(this);
        builder.addStack(this);
        var isGenerateOnce = this.generate.length === 1;
        var snippet = null;

        if (isGenerateOnce) {
          var type = this.getNodeType(builder);
          var nodeData = builder.getDataFromNode(this);
          snippet = nodeData.snippet;

          if (snippet === undefined) {
            snippet = this.generate(builder) || '';
            nodeData.snippet = snippet;
          }

          snippet = builder.format(snippet, type, output);
        } else {
          snippet = this.generate(builder, output) || '';
        }

        builder.removeStack(this);
        return snippet;
      }
    }]);

    return Node;
  }();

  Node.prototype.isNode = true;
  var _default = Node;
  _exports.default = _default;
});
