(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.NodeKeywords = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

  function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var NodeKeywords = /*#__PURE__*/function () {
    function NodeKeywords() {
      _classCallCheck(this, NodeKeywords);

      this.keywords = [];
      this.nodes = [];
      this.keywordsCallback = {};
    }

    _createClass(NodeKeywords, [{
      key: "getNode",
      value: function getNode(name) {
        var node = this.nodes[name];

        if (node === undefined && this.keywordsCallback[name] !== undefined) {
          node = this.keywordsCallback[name](name);
          this.nodes[name] = node;
        }

        return node;
      }
    }, {
      key: "addKeyword",
      value: function addKeyword(name, callback) {
        this.keywords.push(name);
        this.keywordsCallback[name] = callback;
        return this;
      }
    }, {
      key: "parse",
      value: function parse(code) {
        var keywordNames = this.keywords;
        var regExp = new RegExp("\\b".concat(keywordNames.join('\\b|\\b'), "\\b"), 'g');
        var codeKeywords = code.match(regExp);
        var keywordNodes = [];

        if (codeKeywords !== null) {
          var _iterator = _createForOfIteratorHelper(codeKeywords),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var keyword = _step.value;
              var node = this.getNode(keyword);

              if (node !== undefined && keywordNodes.indexOf(node) === -1) {
                keywordNodes.push(node);
              }
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }

        return keywordNodes;
      }
    }, {
      key: "include",
      value: function include(builder, code) {
        var keywordNodes = this.parse(code);

        var _iterator2 = _createForOfIteratorHelper(keywordNodes),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var keywordNode = _step2.value;
            keywordNode.build(builder);
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    }]);

    return NodeKeywords;
  }();

  var _default = NodeKeywords;
  _exports.default = _default;
});
