(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.constants = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NodeUpdateType = _exports.NodeType = _exports.NodeShaderStage = void 0;
  var NodeShaderStage = {
    Vertex: 'vertex',
    Fragment: 'fragment'
  };
  _exports.NodeShaderStage = NodeShaderStage;
  var NodeUpdateType = {
    None: 'none',
    Frame: 'frame',
    Object: 'object'
  };
  _exports.NodeUpdateType = NodeUpdateType;
  var NodeType = {
    Boolean: 'bool',
    Integer: 'int',
    Float: 'float',
    Vector2: 'vec2',
    Vector3: 'vec3',
    Vector4: 'vec4',
    Matrix3: 'mat3',
    Matrix4: 'mat4'
  };
  _exports.NodeType = NodeType;
});
