(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./LineBasicNodeMaterial.js", "./MeshBasicNodeMaterial.js", "./MeshStandardNodeMaterial.js", "./PointsNodeMaterial.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./LineBasicNodeMaterial.js"), require("./MeshBasicNodeMaterial.js"), require("./MeshStandardNodeMaterial.js"), require("./PointsNodeMaterial.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.LineBasicNodeMaterial, global.MeshBasicNodeMaterial, global.MeshStandardNodeMaterial, global.PointsNodeMaterial);
    global.Materials = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _LineBasicNodeMaterial, _MeshBasicNodeMaterial, _MeshStandardNodeMaterial, _PointsNodeMaterial) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "LineBasicNodeMaterial", {
    enumerable: true,
    get: function get() {
      return _LineBasicNodeMaterial.default;
    }
  });
  Object.defineProperty(_exports, "MeshBasicNodeMaterial", {
    enumerable: true,
    get: function get() {
      return _MeshBasicNodeMaterial.default;
    }
  });
  Object.defineProperty(_exports, "MeshStandardNodeMaterial", {
    enumerable: true,
    get: function get() {
      return _MeshStandardNodeMaterial.default;
    }
  });
  Object.defineProperty(_exports, "PointsNodeMaterial", {
    enumerable: true,
    get: function get() {
      return _PointsNodeMaterial.default;
    }
  });
  _LineBasicNodeMaterial = _interopRequireDefault(_LineBasicNodeMaterial);
  _MeshBasicNodeMaterial = _interopRequireDefault(_MeshBasicNodeMaterial);
  _MeshStandardNodeMaterial = _interopRequireDefault(_MeshStandardNodeMaterial);
  _PointsNodeMaterial = _interopRequireDefault(_PointsNodeMaterial);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
});
