(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/TempNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/TempNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.TempNode);
    global.OperatorNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _TempNode2) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _TempNode2 = _interopRequireDefault(_TempNode2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var OperatorNode = /*#__PURE__*/function (_TempNode) {
    _inherits(OperatorNode, _TempNode);

    var _super = _createSuper(OperatorNode);

    function OperatorNode(op, aNode, bNode) {
      var _this;

      _classCallCheck(this, OperatorNode);

      _this = _super.call(this);
      _this.op = op;

      if ((arguments.length <= 3 ? 0 : arguments.length - 3) > 0) {
        var finalBNode = bNode;

        for (var i = 0; i < (arguments.length <= 3 ? 0 : arguments.length - 3); i++) {
          finalBNode = new OperatorNode(op, finalBNode, i + 3 < 3 || arguments.length <= i + 3 ? undefined : arguments[i + 3]);
        }

        bNode = finalBNode;
      }

      _this.aNode = aNode;
      _this.bNode = bNode;
      return _this;
    }

    _createClass(OperatorNode, [{
      key: "getNodeType",
      value: function getNodeType(builder, output) {
        var op = this.op;
        var aNode = this.aNode;
        var bNode = this.bNode;
        var typeA = aNode.getNodeType(builder);
        var typeB = bNode.getNodeType(builder);

        if (typeA === 'void' || typeB === 'void') {
          return 'void';
        } else if (op === '=') {
          return typeA;
        } else if (op === '==' || op === '&&') {
          return 'bool';
        } else if (op === '<=' || op === '>') {
          var length = builder.getTypeLength(output);
          return length > 1 ? "bvec".concat(length) : 'bool';
        } else {
          if (typeA === 'float' && builder.isMatrix(typeB)) {
            return typeB;
          } else if (builder.isMatrix(typeA) && builder.isVector(typeB)) {
            // matrix x vector
            return builder.getVectorFromMatrix(typeA);
          } else if (builder.isVector(typeA) && builder.isMatrix(typeB)) {
            // vector x matrix
            return builder.getVectorFromMatrix(typeB);
          } else if (builder.getTypeLength(typeB) > builder.getTypeLength(typeA)) {
            // anytype x anytype: use the greater length vector
            return typeB;
          }

          return typeA;
        }
      }
    }, {
      key: "generate",
      value: function generate(builder, output) {
        var op = this.op;
        var aNode = this.aNode;
        var bNode = this.bNode;
        var type = this.getNodeType(builder, output);
        var typeA = null;
        var typeB = null;

        if (type !== 'void') {
          typeA = aNode.getNodeType(builder);
          typeB = bNode.getNodeType(builder);

          if (op === '=') {
            typeB = typeA;
          } else if (builder.isMatrix(typeA) && builder.isVector(typeB)) {
            // matrix x vector
            typeB = builder.getVectorFromMatrix(typeA);
          } else if (builder.isVector(typeA) && builder.isMatrix(typeB)) {
            // vector x matrix
            typeA = builder.getVectorFromMatrix(typeB);
          } else {
            // anytype x anytype
            typeA = typeB = type;
          }
        } else {
          typeA = typeB = type;
        }

        var a = aNode.build(builder, typeA);
        var b = bNode.build(builder, typeB);
        var outputLength = builder.getTypeLength(output);

        if (output !== 'void') {
          if (op === '=') {
            builder.addFlowCode("".concat(a, " ").concat(this.op, " ").concat(b));
            return a;
          } else if (op === '>' && outputLength > 1) {
            return "greaterThan( ".concat(a, ", ").concat(b, " )");
          } else if (op === '<=' && outputLength > 1) {
            return "lessThanEqual( ".concat(a, ", ").concat(b, " )");
          } else {
            return "( ".concat(a, " ").concat(this.op, " ").concat(b, " )");
          }
        } else if (typeA !== 'void') {
          return "".concat(a, " ").concat(this.op, " ").concat(b);
        }
      }
    }]);

    return OperatorNode;
  }(_TempNode2.default);

  var _default = OperatorNode;
  _exports.default = _default;
});
