(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/Node.js", "../accessors/UVNode.js", "../ShaderNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/Node.js"), require("../accessors/UVNode.js"), require("../ShaderNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node, global.UVNode, global.ShaderNode);
    global.CheckerNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2, _UVNode, _ShaderNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Node2 = _interopRequireDefault(_Node2);
  _UVNode = _interopRequireDefault(_UVNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var checkerShaderNode = new _ShaderNode.ShaderNode(function (inputs) {
    var uv = (0, _ShaderNode.mul)(inputs.uv, 2.0);
    var cx = (0, _ShaderNode.floor)(uv.x);
    var cy = (0, _ShaderNode.floor)(uv.y);
    var result = (0, _ShaderNode.mod)((0, _ShaderNode.add)(cx, cy), 2.0);
    return (0, _ShaderNode.sign)(result);
  });

  var CheckerNode = /*#__PURE__*/function (_Node) {
    _inherits(CheckerNode, _Node);

    var _super = _createSuper(CheckerNode);

    function CheckerNode() {
      var _this;

      var uvNode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new _UVNode.default();

      _classCallCheck(this, CheckerNode);

      _this = _super.call(this, 'float');
      _this.uvNode = uvNode;
      return _this;
    }

    _createClass(CheckerNode, [{
      key: "generate",
      value: function generate(builder) {
        return checkerShaderNode({
          uv: this.uvNode
        }).build(builder);
      }
    }]);

    return CheckerNode;
  }(_Node2.default);

  var _default = CheckerNode;
  _exports.default = _default;
});
