(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../core/Node.js", "./TimerNode.js", "../ShaderNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../core/Node.js"), require("./TimerNode.js"), require("../ShaderNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Node, global.TimerNode, global.ShaderNode);
    global.OscNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Node2, _TimerNode, _ShaderNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _Node2 = _interopRequireDefault(_Node2);
  _TimerNode = _interopRequireDefault(_TimerNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var OscNode = /*#__PURE__*/function (_Node) {
    _inherits(OscNode, _Node);

    var _super = _createSuper(OscNode);

    function OscNode() {
      var _this;

      var method = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : OscNode.SINE;
      var timeNode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _TimerNode.default();

      _classCallCheck(this, OscNode);

      _this = _super.call(this);
      _this.method = method;
      _this.timeNode = timeNode;
      return _this;
    }

    _createClass(OscNode, [{
      key: "getNodeType",
      value: function getNodeType(builder) {
        return this.timeNode.getNodeType(builder);
      }
    }, {
      key: "generate",
      value: function generate(builder) {
        var method = this.method;
        var timeNode = this.timeNode;
        var outputNode = null;

        if (method === OscNode.SINE) {
          outputNode = (0, _ShaderNode.add)((0, _ShaderNode.mul)((0, _ShaderNode.sin)((0, _ShaderNode.mul)((0, _ShaderNode.add)(timeNode, .75), _ShaderNode.PI2)), .5), .5);
        } else if (method === OscNode.SQUARE) {
          outputNode = (0, _ShaderNode.round)((0, _ShaderNode.fract)(timeNode));
        } else if (method === OscNode.TRIANGLE) {
          outputNode = (0, _ShaderNode.abs)((0, _ShaderNode.sub)(1, (0, _ShaderNode.mul)((0, _ShaderNode.fract)((0, _ShaderNode.add)(timeNode, .5)), 2)));
        } else if (method === OscNode.SAWTOOTH) {
          outputNode = (0, _ShaderNode.fract)(timeNode);
        }

        return outputNode.build(builder);
      }
    }]);

    return OscNode;
  }(_Node2.default);

  _defineProperty(OscNode, "SINE", 'sine');

  _defineProperty(OscNode, "SQUARE", 'square');

  _defineProperty(OscNode, "TRIANGLE", 'triangle');

  _defineProperty(OscNode, "SAWTOOTH", 'sawtooth');

  var _default = OscNode;
  _exports.default = _default;
});
