(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../inputs/FloatNode.js", "../core/constants.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../inputs/FloatNode.js"), require("../core/constants.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.FloatNode, global.constants);
    global.TimerNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _FloatNode2, _constants) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _FloatNode2 = _interopRequireDefault(_FloatNode2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var TimerNode = /*#__PURE__*/function (_FloatNode) {
    _inherits(TimerNode, _FloatNode);

    var _super = _createSuper(TimerNode);

    function TimerNode() {
      var _this;

      var scope = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : TimerNode.LOCAL;

      _classCallCheck(this, TimerNode);

      _this = _super.call(this);
      _this.scope = scope;
      _this.scale = 1;
      _this.updateType = _constants.NodeUpdateType.Frame;
      return _this;
    }

    _createClass(TimerNode, [{
      key: "update",
      value: function update(frame) {
        var scope = this.scope;
        var scale = this.scale;

        if (scope === TimerNode.LOCAL) {
          this.value += frame.deltaTime * scale;
        } else if (scope === TimerNode.DELTA) {
          this.value = frame.deltaTime * scale;
        } else {
          // global
          this.value = frame.time * scale;
        }
      }
    }]);

    return TimerNode;
  }(_FloatNode2.default);

  _defineProperty(TimerNode, "LOCAL", 'local');

  _defineProperty(TimerNode, "GLOBAL", 'global');

  _defineProperty(TimerNode, "DELTA", 'delta');

  var _default = TimerNode;
  _exports.default = _default;
});
