(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./WebGLNodeBuilder.js", "../../nodes/core/NodeFrame.js", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./WebGLNodeBuilder.js"), require("../../nodes/core/NodeFrame.js"), require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGLNodeBuilder, global.NodeFrame, global.three);
    global.WebGLNodes = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGLNodeBuilder, _NodeFrame, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.nodeFrame = void 0;
  _NodeFrame = _interopRequireDefault(_NodeFrame);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

  function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

  var builders = new WeakMap();
  var nodeFrame = new _NodeFrame.default();
  _exports.nodeFrame = nodeFrame;

  _three.Material.prototype.onBuild = function (object, parameters, renderer) {
    builders.set(this, new _WebGLNodeBuilder.WebGLNodeBuilder(object, renderer, parameters).build());
  };

  _three.Material.prototype.onBeforeRender = function (renderer, scene, camera, geometry, object) {
    var nodeBuilder = builders.get(this);

    if (nodeBuilder !== undefined) {
      nodeFrame.material = this;
      nodeFrame.camera = camera;
      nodeFrame.object = object;
      nodeFrame.renderer = renderer;

      var _iterator = _createForOfIteratorHelper(nodeBuilder.updateNodes),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var node = _step.value;
          nodeFrame.updateNode(node);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  };
});
