(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../../nodes/core/ContextNode.js", "../../nodes/accessors/NormalNode.js", "../../nodes/core/ExpressionNode.js", "../../nodes/inputs/FloatNode.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../../nodes/core/ContextNode.js"), require("../../nodes/accessors/NormalNode.js"), require("../../nodes/core/ExpressionNode.js"), require("../../nodes/inputs/FloatNode.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.ContextNode, global.NormalNode, global.ExpressionNode, global.FloatNode);
    global.WebGLPhysicalContextNode = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _ContextNode2, _NormalNode, _ExpressionNode, _FloatNode) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _ContextNode2 = _interopRequireDefault(_ContextNode2);
  _NormalNode = _interopRequireDefault(_NormalNode);
  _ExpressionNode = _interopRequireDefault(_ExpressionNode);
  _FloatNode = _interopRequireDefault(_FloatNode);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

  function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var WebGLPhysicalContextNode = /*#__PURE__*/function (_ContextNode) {
    _inherits(WebGLPhysicalContextNode, _ContextNode);

    var _super = _createSuper(WebGLPhysicalContextNode);

    function WebGLPhysicalContextNode(scope, node) {
      var _this;

      _classCallCheck(this, WebGLPhysicalContextNode);

      _this = _super.call(this, node, 'vec3');
      _this.scope = scope;
      return _this;
    }

    _createClass(WebGLPhysicalContextNode, [{
      key: "generate",
      value: function generate(builder, output) {
        var scope = this.scope;
        var roughness = null;

        if (scope === WebGLPhysicalContextNode.RADIANCE) {
          roughness = new _ExpressionNode.default('roughnessFactor', 'float');
        } else if (scope === WebGLPhysicalContextNode.IRRADIANCE) {
          roughness = new _FloatNode.default(1.0).setConst(true);
          this.context.uv = new _NormalNode.default(_NormalNode.default.WORLD);
        }

        this.context.roughness = roughness;
        return _get(_getPrototypeOf(WebGLPhysicalContextNode.prototype), "generate", this).call(this, builder, output);
      }
    }]);

    return WebGLPhysicalContextNode;
  }(_ContextNode2.default);

  _defineProperty(WebGLPhysicalContextNode, "RADIANCE", 'radiance');

  _defineProperty(WebGLPhysicalContextNode, "IRRADIANCE", 'irradiance');

  var _default = WebGLPhysicalContextNode;
  _exports.default = _default;
});
