(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./WebGPUBinding.js", "./constants.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./WebGPUBinding.js"), require("./constants.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGPUBinding, global.constants);
    global.WebGPUSampledTexture = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGPUBinding2, _constants) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.WebGPUSampledTexture = _exports.WebGPUSampledCubeTexture = _exports.WebGPUSampledArrayTexture = _exports.WebGPUSampled3DTexture = void 0;
  _WebGPUBinding2 = _interopRequireDefault(_WebGPUBinding2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var WebGPUSampledTexture = /*#__PURE__*/function (_WebGPUBinding) {
    _inherits(WebGPUSampledTexture, _WebGPUBinding);

    var _super = _createSuper(WebGPUSampledTexture);

    function WebGPUSampledTexture(name, texture) {
      var _this;

      _classCallCheck(this, WebGPUSampledTexture);

      _this = _super.call(this, name);
      _this.texture = texture;
      _this.dimension = _constants.GPUTextureViewDimension.TwoD;
      _this.type = _constants.GPUBindingType.SampledTexture;
      _this.visibility = GPUShaderStage.FRAGMENT;
      _this.textureGPU = null; // set by the renderer

      return _this;
    }

    _createClass(WebGPUSampledTexture, [{
      key: "getTexture",
      value: function getTexture() {
        return this.texture;
      }
    }]);

    return WebGPUSampledTexture;
  }(_WebGPUBinding2.default);

  _exports.WebGPUSampledTexture = WebGPUSampledTexture;
  WebGPUSampledTexture.prototype.isSampledTexture = true;

  var WebGPUSampledArrayTexture = /*#__PURE__*/function (_WebGPUSampledTexture) {
    _inherits(WebGPUSampledArrayTexture, _WebGPUSampledTexture);

    var _super2 = _createSuper(WebGPUSampledArrayTexture);

    function WebGPUSampledArrayTexture(name) {
      var _this2;

      _classCallCheck(this, WebGPUSampledArrayTexture);

      _this2 = _super2.call(this, name);
      _this2.dimension = _constants.GPUTextureViewDimension.TwoDArray;
      return _this2;
    }

    return _createClass(WebGPUSampledArrayTexture);
  }(WebGPUSampledTexture);

  _exports.WebGPUSampledArrayTexture = WebGPUSampledArrayTexture;
  WebGPUSampledArrayTexture.prototype.isSampledArrayTexture = true;

  var WebGPUSampled3DTexture = /*#__PURE__*/function (_WebGPUSampledTexture2) {
    _inherits(WebGPUSampled3DTexture, _WebGPUSampledTexture2);

    var _super3 = _createSuper(WebGPUSampled3DTexture);

    function WebGPUSampled3DTexture(name) {
      var _this3;

      _classCallCheck(this, WebGPUSampled3DTexture);

      _this3 = _super3.call(this, name);
      _this3.dimension = _constants.GPUTextureViewDimension.ThreeD;
      return _this3;
    }

    return _createClass(WebGPUSampled3DTexture);
  }(WebGPUSampledTexture);

  _exports.WebGPUSampled3DTexture = WebGPUSampled3DTexture;
  WebGPUSampled3DTexture.prototype.isSampled3DTexture = true;

  var WebGPUSampledCubeTexture = /*#__PURE__*/function (_WebGPUSampledTexture3) {
    _inherits(WebGPUSampledCubeTexture, _WebGPUSampledTexture3);

    var _super4 = _createSuper(WebGPUSampledCubeTexture);

    function WebGPUSampledCubeTexture(name) {
      var _this4;

      _classCallCheck(this, WebGPUSampledCubeTexture);

      _this4 = _super4.call(this, name);
      _this4.dimension = _constants.GPUTextureViewDimension.Cube;
      return _this4;
    }

    return _createClass(WebGPUSampledCubeTexture);
  }(WebGPUSampledTexture);

  _exports.WebGPUSampledCubeTexture = WebGPUSampledCubeTexture;
  WebGPUSampledCubeTexture.prototype.isSampledCubeTexture = true;
});
