(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.WebGPUTextureRenderer = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var WebGPUTextureRenderer = /*#__PURE__*/function () {
    function WebGPUTextureRenderer(renderer) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _classCallCheck(this, WebGPUTextureRenderer);

      this.renderer = renderer; // @TODO: Consider to introduce WebGPURenderTarget or rename WebGLRenderTarget to just RenderTarget

      this.renderTarget = new _three.WebGLRenderTarget(options);
    }

    _createClass(WebGPUTextureRenderer, [{
      key: "getTexture",
      value: function getTexture() {
        return this.renderTarget.texture;
      }
    }, {
      key: "setSize",
      value: function setSize(width, height) {
        this.renderTarget.setSize(width, height);
      }
    }, {
      key: "render",
      value: function render(scene, camera) {
        var renderer = this.renderer;
        var renderTarget = this.renderTarget;
        renderer.setRenderTarget(renderTarget);
        renderer.render(scene, camera);
        renderer.setRenderTarget(null);
      }
    }]);

    return WebGPUTextureRenderer;
  }();

  var _default = WebGPUTextureRenderer;
  _exports.default = _default;
});
