(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "three"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("three"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.three);
    global.WebGPUUniform = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _three) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Vector4Uniform = _exports.Vector3Uniform = _exports.Vector2Uniform = _exports.Matrix4Uniform = _exports.Matrix3Uniform = _exports.FloatUniform = _exports.ColorUniform = void 0;

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var WebGPUUniform = /*#__PURE__*/function () {
    function WebGPUUniform(name) {
      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _classCallCheck(this, WebGPUUniform);

      this.name = name;
      this.value = value;
      this.boundary = 0; // used to build the uniform buffer according to the STD140 layout

      this.itemSize = 0;
      this.offset = 0; // this property is set by WebGPUUniformsGroup and marks the start position in the uniform buffer
    }

    _createClass(WebGPUUniform, [{
      key: "setValue",
      value: function setValue(value) {
        this.value = value;
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return this.value;
      }
    }]);

    return WebGPUUniform;
  }();

  var FloatUniform = /*#__PURE__*/function (_WebGPUUniform) {
    _inherits(FloatUniform, _WebGPUUniform);

    var _super = _createSuper(FloatUniform);

    function FloatUniform(name) {
      var _this;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      _classCallCheck(this, FloatUniform);

      _this = _super.call(this, name, value);
      _this.boundary = 4;
      _this.itemSize = 1;
      return _this;
    }

    return _createClass(FloatUniform);
  }(WebGPUUniform);

  _exports.FloatUniform = FloatUniform;
  FloatUniform.prototype.isFloatUniform = true;

  var Vector2Uniform = /*#__PURE__*/function (_WebGPUUniform2) {
    _inherits(Vector2Uniform, _WebGPUUniform2);

    var _super2 = _createSuper(Vector2Uniform);

    function Vector2Uniform(name) {
      var _this2;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Vector2();

      _classCallCheck(this, Vector2Uniform);

      _this2 = _super2.call(this, name, value);
      _this2.boundary = 8;
      _this2.itemSize = 2;
      return _this2;
    }

    return _createClass(Vector2Uniform);
  }(WebGPUUniform);

  _exports.Vector2Uniform = Vector2Uniform;
  Vector2Uniform.prototype.isVector2Uniform = true;

  var Vector3Uniform = /*#__PURE__*/function (_WebGPUUniform3) {
    _inherits(Vector3Uniform, _WebGPUUniform3);

    var _super3 = _createSuper(Vector3Uniform);

    function Vector3Uniform(name) {
      var _this3;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Vector3();

      _classCallCheck(this, Vector3Uniform);

      _this3 = _super3.call(this, name, value);
      _this3.boundary = 16;
      _this3.itemSize = 3;
      return _this3;
    }

    return _createClass(Vector3Uniform);
  }(WebGPUUniform);

  _exports.Vector3Uniform = Vector3Uniform;
  Vector3Uniform.prototype.isVector3Uniform = true;

  var Vector4Uniform = /*#__PURE__*/function (_WebGPUUniform4) {
    _inherits(Vector4Uniform, _WebGPUUniform4);

    var _super4 = _createSuper(Vector4Uniform);

    function Vector4Uniform(name) {
      var _this4;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Vector4();

      _classCallCheck(this, Vector4Uniform);

      _this4 = _super4.call(this, name, value);
      _this4.boundary = 16;
      _this4.itemSize = 4;
      return _this4;
    }

    return _createClass(Vector4Uniform);
  }(WebGPUUniform);

  _exports.Vector4Uniform = Vector4Uniform;
  Vector4Uniform.prototype.isVector4Uniform = true;

  var ColorUniform = /*#__PURE__*/function (_WebGPUUniform5) {
    _inherits(ColorUniform, _WebGPUUniform5);

    var _super5 = _createSuper(ColorUniform);

    function ColorUniform(name) {
      var _this5;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Color();

      _classCallCheck(this, ColorUniform);

      _this5 = _super5.call(this, name, value);
      _this5.boundary = 16;
      _this5.itemSize = 3;
      return _this5;
    }

    return _createClass(ColorUniform);
  }(WebGPUUniform);

  _exports.ColorUniform = ColorUniform;
  ColorUniform.prototype.isColorUniform = true;

  var Matrix3Uniform = /*#__PURE__*/function (_WebGPUUniform6) {
    _inherits(Matrix3Uniform, _WebGPUUniform6);

    var _super6 = _createSuper(Matrix3Uniform);

    function Matrix3Uniform(name) {
      var _this6;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Matrix3();

      _classCallCheck(this, Matrix3Uniform);

      _this6 = _super6.call(this, name, value);
      _this6.boundary = 48;
      _this6.itemSize = 12;
      return _this6;
    }

    return _createClass(Matrix3Uniform);
  }(WebGPUUniform);

  _exports.Matrix3Uniform = Matrix3Uniform;
  Matrix3Uniform.prototype.isMatrix3Uniform = true;

  var Matrix4Uniform = /*#__PURE__*/function (_WebGPUUniform7) {
    _inherits(Matrix4Uniform, _WebGPUUniform7);

    var _super7 = _createSuper(Matrix4Uniform);

    function Matrix4Uniform(name) {
      var _this7;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _three.Matrix4();

      _classCallCheck(this, Matrix4Uniform);

      _this7 = _super7.call(this, name, value);
      _this7.boundary = 64;
      _this7.itemSize = 16;
      return _this7;
    }

    return _createClass(Matrix4Uniform);
  }(WebGPUUniform);

  _exports.Matrix4Uniform = Matrix4Uniform;
  Matrix4Uniform.prototype.isMatrix4Uniform = true;
});
