(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./WebGPUBinding.js", "./WebGPUBufferUtils.js", "./constants.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./WebGPUBinding.js"), require("./WebGPUBufferUtils.js"), require("./constants.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGPUBinding, global.WebGPUBufferUtils, global.constants);
    global.WebGPUUniformBuffer = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGPUBinding2, _WebGPUBufferUtils, _constants) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _WebGPUBinding2 = _interopRequireDefault(_WebGPUBinding2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var WebGPUUniformBuffer = /*#__PURE__*/function (_WebGPUBinding) {
    _inherits(WebGPUUniformBuffer, _WebGPUBinding);

    var _super = _createSuper(WebGPUUniformBuffer);

    function WebGPUUniformBuffer(name) {
      var _this;

      var buffer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _classCallCheck(this, WebGPUUniformBuffer);

      _this = _super.call(this, name);
      _this.bytesPerElement = Float32Array.BYTES_PER_ELEMENT;
      _this.type = _constants.GPUBindingType.UniformBuffer;
      _this.visibility = GPUShaderStage.VERTEX;
      _this.usage = GPUBufferUsage.UNIFORM | GPUBufferUsage.COPY_DST;
      _this.buffer = buffer;
      _this.bufferGPU = null; // set by the renderer

      return _this;
    }

    _createClass(WebGPUUniformBuffer, [{
      key: "getByteLength",
      value: function getByteLength() {
        return (0, _WebGPUBufferUtils.getFloatLength)(this.buffer.byteLength);
      }
    }, {
      key: "getBuffer",
      value: function getBuffer() {
        return this.buffer;
      }
    }, {
      key: "update",
      value: function update() {
        return true;
      }
    }]);

    return WebGPUUniformBuffer;
  }(_WebGPUBinding2.default);

  WebGPUUniformBuffer.prototype.isUniformBuffer = true;
  var _default = WebGPUUniformBuffer;
  _exports.default = _default;
});
