(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./WebGPUUniformBuffer.js", "./constants.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./WebGPUUniformBuffer.js"), require("./constants.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGPUUniformBuffer, global.constants);
    global.WebGPUUniformsGroup = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGPUUniformBuffer2, _constants) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _WebGPUUniformBuffer2 = _interopRequireDefault(_WebGPUUniformBuffer2);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

  function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var WebGPUUniformsGroup = /*#__PURE__*/function (_WebGPUUniformBuffer) {
    _inherits(WebGPUUniformsGroup, _WebGPUUniformBuffer);

    var _super = _createSuper(WebGPUUniformsGroup);

    function WebGPUUniformsGroup(name) {
      var _this;

      _classCallCheck(this, WebGPUUniformsGroup);

      _this = _super.call(this, name); // the order of uniforms in this array must match the order of uniforms in the shader

      _this.uniforms = [];
      return _this;
    }

    _createClass(WebGPUUniformsGroup, [{
      key: "addUniform",
      value: function addUniform(uniform) {
        this.uniforms.push(uniform);
        return this;
      }
    }, {
      key: "removeUniform",
      value: function removeUniform(uniform) {
        var index = this.uniforms.indexOf(uniform);

        if (index !== -1) {
          this.uniforms.splice(index, 1);
        }

        return this;
      }
    }, {
      key: "getBuffer",
      value: function getBuffer() {
        var buffer = this.buffer;

        if (buffer === null) {
          var byteLength = this.getByteLength();
          buffer = new Float32Array(new ArrayBuffer(byteLength));
          this.buffer = buffer;
        }

        return buffer;
      }
    }, {
      key: "getByteLength",
      value: function getByteLength() {
        var offset = 0; // global buffer offset in bytes

        for (var i = 0, l = this.uniforms.length; i < l; i++) {
          var uniform = this.uniforms[i]; // offset within a single chunk in bytes

          var chunkOffset = offset % _constants.GPUChunkSize;
          var remainingSizeInChunk = _constants.GPUChunkSize - chunkOffset; // conformance tests

          if (chunkOffset !== 0 && remainingSizeInChunk - uniform.boundary < 0) {
            // check for chunk overflow
            offset += _constants.GPUChunkSize - chunkOffset;
          } else if (chunkOffset % uniform.boundary !== 0) {
            // check for correct alignment
            offset += chunkOffset % uniform.boundary;
          }

          uniform.offset = offset / this.bytesPerElement;
          offset += uniform.itemSize * this.bytesPerElement;
        }

        return offset;
      }
    }, {
      key: "update",
      value: function update() {
        var updated = false;

        var _iterator = _createForOfIteratorHelper(this.uniforms),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var uniform = _step.value;

            if (this.updateByType(uniform) === true) {
              updated = true;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        return updated;
      }
    }, {
      key: "updateByType",
      value: function updateByType(uniform) {
        if (uniform.isFloatUniform) return this.updateNumber(uniform);
        if (uniform.isVector2Uniform) return this.updateVector2(uniform);
        if (uniform.isVector3Uniform) return this.updateVector3(uniform);
        if (uniform.isVector4Uniform) return this.updateVector4(uniform);
        if (uniform.isColorUniform) return this.updateColor(uniform);
        if (uniform.isMatrix3Uniform) return this.updateMatrix3(uniform);
        if (uniform.isMatrix4Uniform) return this.updateMatrix4(uniform);
        console.error('THREE.WebGPUUniformsGroup: Unsupported uniform type.', uniform);
      }
    }, {
      key: "updateNumber",
      value: function updateNumber(uniform) {
        var updated = false;
        var a = this.buffer;
        var v = uniform.getValue();
        var offset = uniform.offset;

        if (a[offset] !== v) {
          a[offset] = v;
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateVector2",
      value: function updateVector2(uniform) {
        var updated = false;
        var a = this.buffer;
        var v = uniform.getValue();
        var offset = uniform.offset;

        if (a[offset + 0] !== v.x || a[offset + 1] !== v.y) {
          a[offset + 0] = v.x;
          a[offset + 1] = v.y;
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateVector3",
      value: function updateVector3(uniform) {
        var updated = false;
        var a = this.buffer;
        var v = uniform.getValue();
        var offset = uniform.offset;

        if (a[offset + 0] !== v.x || a[offset + 1] !== v.y || a[offset + 2] !== v.z) {
          a[offset + 0] = v.x;
          a[offset + 1] = v.y;
          a[offset + 2] = v.z;
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateVector4",
      value: function updateVector4(uniform) {
        var updated = false;
        var a = this.buffer;
        var v = uniform.getValue();
        var offset = uniform.offset;

        if (a[offset + 0] !== v.x || a[offset + 1] !== v.y || a[offset + 2] !== v.z || a[offset + 4] !== v.w) {
          a[offset + 0] = v.x;
          a[offset + 1] = v.y;
          a[offset + 2] = v.z;
          a[offset + 3] = v.w;
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateColor",
      value: function updateColor(uniform) {
        var updated = false;
        var a = this.buffer;
        var c = uniform.getValue();
        var offset = uniform.offset;

        if (a[offset + 0] !== c.r || a[offset + 1] !== c.g || a[offset + 2] !== c.b) {
          a[offset + 0] = c.r;
          a[offset + 1] = c.g;
          a[offset + 2] = c.b;
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateMatrix3",
      value: function updateMatrix3(uniform) {
        var updated = false;
        var a = this.buffer;
        var e = uniform.getValue().elements;
        var offset = uniform.offset;

        if (a[offset + 0] !== e[0] || a[offset + 1] !== e[1] || a[offset + 2] !== e[2] || a[offset + 4] !== e[3] || a[offset + 5] !== e[4] || a[offset + 6] !== e[5] || a[offset + 8] !== e[6] || a[offset + 9] !== e[7] || a[offset + 10] !== e[8]) {
          a[offset + 0] = e[0];
          a[offset + 1] = e[1];
          a[offset + 2] = e[2];
          a[offset + 4] = e[3];
          a[offset + 5] = e[4];
          a[offset + 6] = e[5];
          a[offset + 8] = e[6];
          a[offset + 9] = e[7];
          a[offset + 10] = e[8];
          updated = true;
        }

        return updated;
      }
    }, {
      key: "updateMatrix4",
      value: function updateMatrix4(uniform) {
        var updated = false;
        var a = this.buffer;
        var e = uniform.getValue().elements;
        var offset = uniform.offset;

        if (arraysEqual(a, e, offset) === false) {
          a.set(e, offset);
          updated = true;
        }

        return updated;
      }
    }]);

    return WebGPUUniformsGroup;
  }(_WebGPUUniformBuffer2.default);

  function arraysEqual(a, b, offset) {
    for (var i = 0, l = b.length; i < l; i++) {
      if (a[offset + i] !== b[i]) return false;
    }

    return true;
  }

  WebGPUUniformsGroup.prototype.isUniformsGroup = true;
  var _default = WebGPUUniformsGroup;
  _exports.default = _default;
});
