(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "../WebGPUUniform.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("../WebGPUUniform.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGPUUniform);
    global.WebGPUNodeUniform = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGPUUniform) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Vector4NodeUniform = _exports.Vector3NodeUniform = _exports.Vector2NodeUniform = _exports.Matrix4NodeUniform = _exports.Matrix3NodeUniform = _exports.FloatNodeUniform = _exports.ColorNodeUniform = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

  function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  var FloatNodeUniform = /*#__PURE__*/function (_FloatUniform) {
    _inherits(FloatNodeUniform, _FloatUniform);

    var _super = _createSuper(FloatNodeUniform);

    function FloatNodeUniform(nodeUniform) {
      var _this;

      _classCallCheck(this, FloatNodeUniform);

      _this = _super.call(this, nodeUniform.name, nodeUniform.value);
      _this.nodeUniform = nodeUniform;
      return _this;
    }

    _createClass(FloatNodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return FloatNodeUniform;
  }(_WebGPUUniform.FloatUniform);

  _exports.FloatNodeUniform = FloatNodeUniform;

  var Vector2NodeUniform = /*#__PURE__*/function (_Vector2Uniform) {
    _inherits(Vector2NodeUniform, _Vector2Uniform);

    var _super2 = _createSuper(Vector2NodeUniform);

    function Vector2NodeUniform(nodeUniform) {
      var _this2;

      _classCallCheck(this, Vector2NodeUniform);

      _this2 = _super2.call(this, nodeUniform.name, nodeUniform.value);
      _this2.nodeUniform = nodeUniform;
      return _this2;
    }

    _createClass(Vector2NodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return Vector2NodeUniform;
  }(_WebGPUUniform.Vector2Uniform);

  _exports.Vector2NodeUniform = Vector2NodeUniform;

  var Vector3NodeUniform = /*#__PURE__*/function (_Vector3Uniform) {
    _inherits(Vector3NodeUniform, _Vector3Uniform);

    var _super3 = _createSuper(Vector3NodeUniform);

    function Vector3NodeUniform(nodeUniform) {
      var _this3;

      _classCallCheck(this, Vector3NodeUniform);

      _this3 = _super3.call(this, nodeUniform.name, nodeUniform.value);
      _this3.nodeUniform = nodeUniform;
      return _this3;
    }

    _createClass(Vector3NodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return Vector3NodeUniform;
  }(_WebGPUUniform.Vector3Uniform);

  _exports.Vector3NodeUniform = Vector3NodeUniform;

  var Vector4NodeUniform = /*#__PURE__*/function (_Vector4Uniform) {
    _inherits(Vector4NodeUniform, _Vector4Uniform);

    var _super4 = _createSuper(Vector4NodeUniform);

    function Vector4NodeUniform(nodeUniform) {
      var _this4;

      _classCallCheck(this, Vector4NodeUniform);

      _this4 = _super4.call(this, nodeUniform.name, nodeUniform.value);
      _this4.nodeUniform = nodeUniform;
      return _this4;
    }

    _createClass(Vector4NodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return Vector4NodeUniform;
  }(_WebGPUUniform.Vector4Uniform);

  _exports.Vector4NodeUniform = Vector4NodeUniform;

  var ColorNodeUniform = /*#__PURE__*/function (_ColorUniform) {
    _inherits(ColorNodeUniform, _ColorUniform);

    var _super5 = _createSuper(ColorNodeUniform);

    function ColorNodeUniform(nodeUniform) {
      var _this5;

      _classCallCheck(this, ColorNodeUniform);

      _this5 = _super5.call(this, nodeUniform.name, nodeUniform.value);
      _this5.nodeUniform = nodeUniform;
      return _this5;
    }

    _createClass(ColorNodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return ColorNodeUniform;
  }(_WebGPUUniform.ColorUniform);

  _exports.ColorNodeUniform = ColorNodeUniform;

  var Matrix3NodeUniform = /*#__PURE__*/function (_Matrix3Uniform) {
    _inherits(Matrix3NodeUniform, _Matrix3Uniform);

    var _super6 = _createSuper(Matrix3NodeUniform);

    function Matrix3NodeUniform(nodeUniform) {
      var _this6;

      _classCallCheck(this, Matrix3NodeUniform);

      _this6 = _super6.call(this, nodeUniform.name, nodeUniform.value);
      _this6.nodeUniform = nodeUniform;
      return _this6;
    }

    _createClass(Matrix3NodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return Matrix3NodeUniform;
  }(_WebGPUUniform.Matrix3Uniform);

  _exports.Matrix3NodeUniform = Matrix3NodeUniform;

  var Matrix4NodeUniform = /*#__PURE__*/function (_Matrix4Uniform) {
    _inherits(Matrix4NodeUniform, _Matrix4Uniform);

    var _super7 = _createSuper(Matrix4NodeUniform);

    function Matrix4NodeUniform(nodeUniform) {
      var _this7;

      _classCallCheck(this, Matrix4NodeUniform);

      _this7 = _super7.call(this, nodeUniform.name, nodeUniform.value);
      _this7.nodeUniform = nodeUniform;
      return _this7;
    }

    _createClass(Matrix4NodeUniform, [{
      key: "getValue",
      value: function getValue() {
        return this.nodeUniform.value;
      }
    }]);

    return Matrix4NodeUniform;
  }(_WebGPUUniform.Matrix4Uniform);

  _exports.Matrix4NodeUniform = Matrix4NodeUniform;
});
