(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./WebGPUNodeBuilder.js", "../../nodes/core/NodeFrame.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./WebGPUNodeBuilder.js"), require("../../nodes/core/NodeFrame.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.WebGPUNodeBuilder, global.NodeFrame);
    global.WebGPUNodes = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _WebGPUNodeBuilder, _NodeFrame) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _WebGPUNodeBuilder = _interopRequireDefault(_WebGPUNodeBuilder);
  _NodeFrame = _interopRequireDefault(_NodeFrame);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

  function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

  function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var WebGPUNodes = /*#__PURE__*/function () {
    function WebGPUNodes(renderer) {
      _classCallCheck(this, WebGPUNodes);

      this.renderer = renderer;
      this.nodeFrame = new _NodeFrame.default();
      this.builders = new WeakMap();
    }

    _createClass(WebGPUNodes, [{
      key: "get",
      value: function get(object, lightNode) {
        var nodeBuilder = this.builders.get(object);

        if (nodeBuilder === undefined) {
          nodeBuilder = new _WebGPUNodeBuilder.default(object, this.renderer, lightNode).build();
          this.builders.set(object, nodeBuilder);
        }

        return nodeBuilder;
      }
    }, {
      key: "remove",
      value: function remove(object) {
        this.builders.delete(object);
      }
    }, {
      key: "updateFrame",
      value: function updateFrame() {
        this.nodeFrame.update();
      }
    }, {
      key: "update",
      value: function update(object, camera, lightNode) {
        var renderer = this.renderer;
        var material = object.material;
        var nodeBuilder = this.get(object, lightNode);
        var nodeFrame = this.nodeFrame;
        nodeFrame.material = material;
        nodeFrame.camera = camera;
        nodeFrame.object = object;
        nodeFrame.renderer = renderer;

        var _iterator = _createForOfIteratorHelper(nodeBuilder.updateNodes),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var node = _step.value;
            nodeFrame.updateNode(node);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }, {
      key: "dispose",
      value: function dispose() {
        this.builders = new WeakMap();
      }
    }]);

    return WebGPUNodes;
  }();

  var _default = WebGPUNodes;
  _exports.default = _default;
});
