(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.ARButton = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ARButton = void 0;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var ARButton = /*#__PURE__*/function () {
    function ARButton() {
      _classCallCheck(this, ARButton);
    }

    _createClass(ARButton, null, [{
      key: "createButton",
      value: function createButton(renderer) {
        var sessionInit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var button = document.createElement('button');

        function
          /*device*/
        showStartAR() {
          if (sessionInit.domOverlay === undefined) {
            var overlay = document.createElement('div');
            overlay.style.display = 'none';
            document.body.appendChild(overlay);
            var svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
            svg.setAttribute('width', 38);
            svg.setAttribute('height', 38);
            svg.style.position = 'absolute';
            svg.style.right = '20px';
            svg.style.top = '20px';
            svg.addEventListener('click', function () {
              currentSession.end();
            });
            overlay.appendChild(svg);
            var path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
            path.setAttribute('d', 'M 12,12 L 28,28 M 28,12 12,28');
            path.setAttribute('stroke', '#fff');
            path.setAttribute('stroke-width', 2);
            svg.appendChild(path);

            if (sessionInit.optionalFeatures === undefined) {
              sessionInit.optionalFeatures = [];
            }

            sessionInit.optionalFeatures.push('dom-overlay');
            sessionInit.domOverlay = {
              root: overlay
            };
          } //


          var currentSession = null;

          function onSessionStarted(_x) {
            return _onSessionStarted.apply(this, arguments);
          }

          function _onSessionStarted() {
            _onSessionStarted = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(session) {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      session.addEventListener('end', onSessionEnded);
                      renderer.xr.setReferenceSpaceType('local');
                      _context.next = 4;
                      return renderer.xr.setSession(session);

                    case 4:
                      button.textContent = 'STOP AR';
                      sessionInit.domOverlay.root.style.display = '';
                      currentSession = session;

                    case 7:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            }));
            return _onSessionStarted.apply(this, arguments);
          }

          function
            /*event*/
          onSessionEnded() {
            currentSession.removeEventListener('end', onSessionEnded);
            button.textContent = 'START AR';
            sessionInit.domOverlay.root.style.display = 'none';
            currentSession = null;
          } //


          button.style.display = '';
          button.style.cursor = 'pointer';
          button.style.left = 'calc(50% - 50px)';
          button.style.width = '100px';
          button.textContent = 'START AR';

          button.onmouseenter = function () {
            button.style.opacity = '1.0';
          };

          button.onmouseleave = function () {
            button.style.opacity = '0.5';
          };

          button.onclick = function () {
            if (currentSession === null) {
              navigator.xr.requestSession('immersive-ar', sessionInit).then(onSessionStarted);
            } else {
              currentSession.end();
            }
          };
        }

        function disableButton() {
          button.style.display = '';
          button.style.cursor = 'auto';
          button.style.left = 'calc(50% - 75px)';
          button.style.width = '150px';
          button.onmouseenter = null;
          button.onmouseleave = null;
          button.onclick = null;
        }

        function showARNotSupported() {
          disableButton();
          button.textContent = 'AR NOT SUPPORTED';
        }

        function stylizeElement(element) {
          element.style.position = 'absolute';
          element.style.bottom = '20px';
          element.style.padding = '12px 6px';
          element.style.border = '1px solid #fff';
          element.style.borderRadius = '4px';
          element.style.background = 'rgba(0,0,0,0.1)';
          element.style.color = '#fff';
          element.style.font = 'normal 13px sans-serif';
          element.style.textAlign = 'center';
          element.style.opacity = '0.5';
          element.style.outline = 'none';
          element.style.zIndex = '999';
        }

        if ('xr' in navigator) {
          button.id = 'ARButton';
          button.style.display = 'none';
          stylizeElement(button);
          navigator.xr.isSessionSupported('immersive-ar').then(function (supported) {
            supported ? showStartAR() : showARNotSupported();
          }).catch(showARNotSupported);
          return button;
        } else {
          var message = document.createElement('a');

          if (window.isSecureContext === false) {
            message.href = document.location.href.replace(/^http:/, 'https:');
            message.innerHTML = 'WEBXR NEEDS HTTPS'; // TODO Improve message
          } else {
            message.href = 'https://immersiveweb.dev/';
            message.innerHTML = 'WEBXR NOT AVAILABLE';
          }

          message.style.left = 'calc(50% - 90px)';
          message.style.width = '180px';
          message.style.textDecoration = 'none';
          stylizeElement(message);
          return message;
        }
      }
    }]);

    return ARButton;
  }();

  _exports.ARButton = ARButton;
});
